#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <memory.h>
#include <assert.h>
#include <sys/types.h>
#include <limits.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#ifndef WIN32
#include <unistd.h>
#include <sys/param.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <pwd.h>
#include <netdb.h>
#include <stropts.h>
#else 
#include <windows.h>
#include <winbase.h>
#endif
#ifdef SOLARIS
#include <sys/file.h>
#endif
#include "perfcolorcodes.h"
#include "perfometer.h"

/* $Id: api.c,v 1.1 2002/08/13 06:58:22 mucci Exp $ */

/* This file contains the API functions for non-dynaprof users of the
   perfometer probe. mucci@cs.utk.edu */

#define DEF_COLOR WHITE
#define DEF_LABEL "Default"

static void *default_perfometer = NULL;

/*
 * Simple fortran to c string conversion
 */

static char * fstringtoc ( char * in ) {
  static char tmpin[1028];
  int i=0;
  while ( i<1028&&isalnum( in[i] )) i++;
  strncpy( tmpin, in, i );
  tmpin[i] = '\0';
  return tmpin;
}

/* C */

void mark_perfometer(int color, char *label) { _internal_mark_perfometer(default_perfometer, color, fstringtoc(label)); }
void perfometer() { default_perfometer = _internal_perfometer(DEF_COLOR, DEF_LABEL); }
void stop_perfometer() { _internal_stop_perfometer(default_perfometer); }

/* Fortran */

void MARK_PERFOMETER(int *color, char *label) {
    _internal_mark_perfometer(default_perfometer,*color, fstringtoc(label)); }
void mark_perfometer_(int *color, char *label) {
    _internal_mark_perfometer(default_perfometer,*color, fstringtoc(label)); }
void mark_perfometer__(int *color, char *label) {
    _internal_mark_perfometer(default_perfometer,*color, fstringtoc(label)); }
void _MARK_PERFOMETER(int *color, char *label) {
        _internal_mark_perfometer(default_perfometer,*color,fstringtoc(label)); }

void PERFOMETER() { _internal_perfometer(DEF_COLOR, DEF_LABEL); }
void perfometer_() { _internal_perfometer(DEF_COLOR, DEF_LABEL); }
void perfometer__() { _internal_perfometer(DEF_COLOR, DEF_LABEL); }
void _PERFOMETER() { _internal_perfometer(DEF_COLOR, DEF_LABEL); }

void STOP_PERFOMETER() { _internal_stop_perfometer(default_perfometer); }
void stop_perfometer_() { _internal_stop_perfometer(default_perfometer); }
void stop_perfometer__() { _internal_stop_perfometer(default_perfometer); }
void _STOP_PERFOMETER() { _internal_stop_perfometer(default_perfometer); }
