cc file eos.f contains:

cc file  e.f       contains:  eLQDS.f,  eM.f,  eSLDS.f
cc file  phdiag.f  contains:  TLofx.f, xLofT.f,  TSofx.f, xSofT.f

c########1#########2#########3#########4#########5#########6#########7##
c Fs-Px
        FUNCTION eLQDS(  xij )
c_______________________________________________________________lines 23
c 6-29-92  finds value of eLQDS(x) = eL(x,TL(x))=e on LIQUIDUS
c          = DhfusA + cpLintg(xE,TE,TL(x)) + hhLintg(xE,x,TL(x)) 
Called by  PROFLUX(), PHASE()
Calls FUNCTIONS TLofx, cpLintg, hhLintg
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/constant/ DhfusA, DhfusB, h0SA, h0SB, eS0TE, eS1TE
       EXTERNAL TLofx, cpLintg, hhLintg

                 TLij = TLofx( xij )
              cpLigTL = cpLintg(xE,TE,TLij)
                hhLig = hhLintg(xE,xij,TLij)
             eLQDS    =   eS0TE + DhfusE + cpLigTL + hhLig
      return
      end

c########1#########2#########3#########4#########5#########6#########7##
c Fs-Px 
        FUNCTION eM(  xij,  Tij,  NeMeval ) 
c______________________________________________________________ lines 51
c11- 9-92 Fs-Px, left out eij, only called for TE < T < TB
c 6-29-92 finds value of eM(xij,Tij)  for solving eM - eij =0
c           where  eM(x,T) = aLAM * eL(xL(T),T) + (1-aLAM) * eS(xS(T),T)
Called by TinMUSH() solver from mushy PHASE()
Calls FUNCTIONS  xLofT, xSofT, hhLintg, hhSintg, cpLintg, cpSintg
c*******
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/constant/ DhfusA, DhfusB, h0SA, h0SB, eS0TE, eS1TE

         EXTERNAL xLofT, xSofT, hhLintg, hhSintg, cpLintg, cpSintg
cd     &         , eLQDS, eSLDS 

cc.....to translate x=mole fraction to C=weight fraction  Px.....
cd           CC( xii ) = WB * xii / ( WA + Wdiff * xii )

c------------------------- evaluate eM(x,T) ----------------------------
c                count Number of evaluations of eM() by ZEROIN()
        NeMeval = NeMeval + 1
cd                Cij = CC( xij )
           xLij = xLofT( Tij )
cd                CLij = CC( xLij )
           xSij = xSofT( Tij ) 
cd                CSij = CC( xSij )
                alam   = ( xSij - xij ) / ( xSij - xLij )
                Wfactor= (WA + Wdiff * xLij)/(WA + Wdiff * xij)
                aLAMij = alam * Wfactor
cd   same as:   aLAMDA = ( CSij - Cij ) / ( CSij - CLij )

c..             ..............find eLij = eL(xL(T),T).........
                cpLig = cpLintg( xE, TE, Tij )
                hhLig = hhLintg( xE, xLij, Tij )
          eLij = eS0TE + DhfusE + cpLig + hhLig
c          eLij = eLQDS( xLij )

cd check value of eLij via eLQDS
cd           eLdiff = eLij - eLQDS( xLij )
cd         if( eLdiff .NE. 0. ) write(6,*)'in eM: eLij =/= eLijLQDS',
cd     &                                  ' eLdiff =',eLdiff
cd ...they agree to about 5 or 6 decimals

c..             ..............find eSij = eS(xS(T),T).........
                hhSig = hhSintg( xE, xSij, TE  )
                cpSig = cpSintg( xSij, TE, Tij )
          eSij = eS0TE + hhSig + cpSig
c          eSij = eSLDS( xSij )

c..        ...................hence find eM(x,T).....................
                eM = aLAMij * eLij + (1. - aLAMij) * eSij
        return
        end

c########1#########2#########3#########4#########5#########6#########7##
c Fs-Px
        FUNCTION eSLDS( xij )
c_______________________________________________________________lines 30
c 6-29-92  finds value of eSLDS(x) = eS(x,TS(x)) = e on SOLIDUS
c where Dhfus(xE,TE)  (J/g) = heat of fusion at (xE,TE)=(0,TA)
Called by  PROFLUX(), PHASE()
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/constant/ DhfusA, DhfusB, h0SA, h0SB, eS0TE, eS1TE

       EXTERNAL TSofx, cpSintg, hhSintg

                TSij = TSofx( xij )
               hhSig = hhSintg( xE ,xij, TE  )
             cpSigTS = cpSintg( xij, TE, TSij)
            eSLDS    =    eS0TE + hhSig + cpSigTS
99    return
      end

ccc file  phdiag.f   contains:  TLofx.f, xLofT.f,  TSofx.f, xSofT.f

c#####.##1#########2#########3#########4#########5#########6#########7##
c Fs-Px 

      FUNCTION TLofx( xij ) 
c______________________________________________________________ lines 43
c 6-12-93       Gary's newest fits of 3-22-93 (ATAN instead of sqrt)
c 2-20-93       new fit from Gary of 2-9-93
c11-6-92  Fs-Px liquidus
computes.......TL(x) = LIQUIDUS T at x for Fs-Px 
called by: PHASE(), eM()
c input:  xij 
c output: TLxij = TL( xij )

                    implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      DATA coTL1/ 0.3363d0 /, coTL2/ -0.3887d0 /,  coTL3/ 0.2576d0 /

cc find Cij corresponding to the given xij
           Cij = WB * xij / ( WA + Wdiff * xij )

         Temp = coTL1* ATAN(Cij) + coTL2* Cij + coTL3* LOG(1.0+10.0*Cij)
cc find TL(x):
               TLofx = TA * ( 1. + Temp ) 
      return
      end


c#####.##1#########2#########3#########4#########5#########6#########7##
c Fs-Px 

      FUNCTION xLofT( Tij ) 
c______________________________________________________________ lines 83
c 6-12-93        Gary's newest fits of 3-22-93 (ATAN instead of sqrt)
c 2-20-93        new fit from Gary of 2-9-93
c 11-6-92  Fs-Px binary, bisection and Newton
computes.......xL(T) = LIQUIDUS xB at T by solving TL(C)=Tij
called by: PHASE(), eM()
c input:  Tij in degC
c output: xLofT = xL( Tij ) = WA * CL / (WAn - Wdiff * CL)
c--------
         implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      DATA coTL1/ 0.3363d0 /, coTL2/ -0.3887d0 /,  coTL3/ 0.2576d0 /

cc.....to translate C=weight fraction to x=mole fraction B.....
           XX( Cij ) = WA * Cij / ( WB - Wdiff * Cij )
cc.....formula for function FofX(X), depends on the fit used in TLofx:
       FofX(X0) = coTL1*ATAN(X0)+coTL2*X0+coTL3*LOG(1.+10.*X0) - ToTm1
cc.....formula for function DFofX(X), depends on the fit used in TLofx:
       DFofX( X0 ) = coTL1/(1.+X0*X0) + coTL2 + coTL3/(.1 + X0)

       maxITER = 1000
           TOL = 1.d-12
          TOL2 = 1.d-10
cd       write(6,*)'    T      CL(T)     residual          ITERations'
cd      DO 5  Tij = TA, TB, 10.
 
cc....................check the Tij first...........
        if( Tij .LT. TA  .OR.  Tij .GT. TB ) goto 99
compute the CL of Tij, inverse to T = TL(C) via bisection/Newton:
cc      by solving  F(C) := coTL1*ATAN(C)+coTL2*C+coTL3*LOG(1+10*C) = 0 
cc  OR  by solving  F(x) := TLofx( x ) - Tij = 0
cc Note: here X = C
        ToTm1 = Tij / TA - 1.0

         X1 = 0.0
         X2 = 1.0 
         F1 = - ToTm1
         F2 = FofX( X2 )
cd         F2 = coTL1*ATAN(X2) + coTL2*X2 + coTL3*LOG(1.+10.*X2)
c v.2        F1 = TLofx( X1 ) - Tij
c v.2        F2 = TLofx( X2 ) - Tij
          Xij = .5 * ( X1 + X2 )
         DXold = ABS(X2-X1)
         DX = DXold
          F = FofX( Xij )
cd             atanX = ATAN( Xij )
cd          F = coTL1*atanX + coTL2*Xij + coTL3*LOG(10*Xij+1.) - ToTm1
c v.2        F = TLofx( Xij ) - Tij

      if( ABS(F) .LE. TOL2 ) goto 50
          DF = DFofX( Xij )
cd          DF = coTL1/(1.+X0*X0) + coTL2 + coTL3/(.1+Xij)

        DO 10  ITER = 1, maxITER

          if( ((Xij-X2)*DF-F)*((Xij-X1)*DF-F) .GE. 0. ) then
             DXold = DX
             DX    = .5*(X2-X1)
             Xij = X1 + DX
              if( ABS(DX) .LE. TOL ) goto 50
          else
             DXold = DX
             DX = F / DF
                old = Xij
             Xij = Xij - DX
             if( old .EQ. Xij ) goto 50
          endif
              if( ABS(DX) .LE. TOL ) goto 50
          F = FofX( Xij )
          DF = DFofX( Xij )
cd             atanX = ATAN( Xij )
cd          F = coTL1*atanX + coTL2*Xij + coTL3*LOG(10*Xij+1.) - ToTm1
cd          DF = coTL1/(1.+X0*X0) + coTL2 + coTL3/(.1+Xij)
           if( F .LT. 0. ) then
               X1 = Xij
               F1 = F
           else
               X2 = Xij
               F2 = F
           endif

 10     CONTINUE

           write(6,*)'xLofT: exceeded maxITER, residual=', F

cd 50        write(6,51) Tij, Xij, F, ITER
cd  51       format( f8.1, 2x, f6.3, 2x, e12.2, 2x, I5 )

cd5      CONTINUE
cc.................. change weight fraction to mole fraction of B:
  50        xLofT = XX( Xij )
c........
         return
99             write(6,*)'xLofT(T) was called with T<TA or T>TB, EXIT'
               write(6,*)'xLofT: Tij = ', Tij
         stop
         end

c#####.##1#########2#########3#########4#########5#########6#########7##
c Fs-Px 

      FUNCTION TSofx( xij ) 
c______________________________________________________________ lines 29
c 6-12-93       Gary's newest fits of 3-22-93 (ATAN instead of sqrt)
c11-6-92  Fs-Px solidus,  2-15-93 new fit from Gary of 2-9-93
computes.......TS(x) = SOLIDUS T at x for Fs-Px
called by: PHASE(), eM()
c input:  xij 
c output: TSxij = TS( xij ) = TS( WB*xij/(WA + (WB-WA)*xij) )

                    implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      DATA coTS1/0.5242d0/, coTS2/-0.6479d0/, coTS3/0.1458d0/

cc find Cij corresponding to the given xij
           Cij = WB * xij / ( WA + Wdiff * xij )
           C00 = .5
       if( Cij .LE. C00 ) then
                              TSofx = TA
                              goto 99
cd                          write(6,*)'TSofx: called for C < C00, STOP'
cd                          STOP 
       endif
cc     .......else find TS(x):
       CmC0 = Cij - C00
       Temp = coTS1*ATAN(CmC0) + coTS2*CmC0 + coTS3*LOG(1.0+1.d2*CmC0)
                TSofx = TA * ( 1. + Temp ) 
99       return
         end


c#####.##1#########2#########3#########4#########5#########6#########7##
c Fs-Px 

      FUNCTION xSofT( Tij ) 
c______________________________________________________________ lines 48
c 6-11-93        Gary's newest fits of 3-22-93 (ATAN instead of sqrt)
c 2-20-93        new fit from Gary of 2-9-93
c 11-6-92  Fs-Px binary, bisection and Newton
computes.......xS(T) = SOLIDUS xB at T by solving TS(C)=Tij, via Newton 
called by: PHASE(), eM()
c input:  Tij in degC
c output: xSofT = xS( Tij ) = WA * CS / (WB - Wdiff * CS)
c--------
         implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      DATA coTS1/0.5242d0/, coTS2/-0.6479d0/, coTS3/0.1458d0/

cc.....to translate C=weight fraction to x=mole fraction B.....
           XX( Cij ) = WA * Cij / ( WB - Wdiff * Cij )
cc.....formula for function FofX(X), depends on the fit used in TSofx:
       FofX(X0) = coTS1*ATAN(X0)+coTS2*X0+coTS3*LOG(1.+100.0*X0) - ToTm1
cc.....formula for function DFofX(X), depends on the fit used in TSofx:
       DFofX( X0 ) = coTS1/(1.+X0*X0) + coTS2 + coTS3/(1.0e-2 + X0)

       maxITER = 1000
           TOL = 1.d-12
          TOL2 = 1.d-10
           C00 = .5
cd       write(6,*)'    T      CS(T)     residual          ITERations'
cd      DO 5  Tij = TA, TB, 10.

cc....................check the Tij first...........
cc save some work:
        if( Tij .EQ. TA ) then
                              Cij = C00
                              xSofT = XX( Cij )
                              return
        endif
        if( Tij .LT. TA  .OR.  Tij .GT. TB ) goto 99
compute the CS of Tij, inverse to T = TS(C) 
cc      by solving  F(C) := coTS1*ATAN(C)+coTS2*C+coTS3*LOG(1+100*C)= 0
cc  OR  by solving  F(x) := TSofx( x ) - Tij = 0

cc--------------------- via Newton:    NO GOOD !
cc--------------------- via ZEROIN: solve  TSofx( xSofT ) - Tij = 0 :
cd       AX = XX( .48 )
cd       BX = 1.0
cd                 xSofT = ZEROIN( AX, BX, TOL, Tij )

cc----------------------- via bisection / Newton:
cc Note: in version 1 : X = C - C00, in v.2: X = C

        ToTm1 = Tij / TA - 1.0
           X1 = 0.0
           X2 = 1.0 - C00 
           F1 = - ToTm1
           F2 = FofX( X2 )
c v.2         F1 = TSofx( X1 ) - Tij
c v.2         F2 = TSofx( X2 ) - Tij
      if( F1 .EQ. 0. ) then
                           Xij = X1
                           goto 50
      endif
      if( F1 * F2 .GT. 0. ) write(6,*)'xSofT:  F1*F2 NOT <0  @T=',Tij
      if( F1 .GT. 0. ) then
                       Xswap = X1
                       X1 = X2
                       X2 = Xswap
                       Fswap = F1
                       F1 = F2
                       F2 = Fswap
      endif 
           Xij = .5 * ( X1 + X2 )
         DXold = ABS(X2-X1)
            DX = DXold
             F = FofX( Xij )
c v.2         F = TSofx( Xij ) - Tij
      if( ABS(F) .LE. TOL2 ) goto 50
          DF = DFofX( Xij )

        DO 10  ITER = 1, maxITER

          if( ((Xij-X2)*DF-F)*((Xij-X1)*DF-F) .GE. 0. ) then
             DXold = DX
             DX    = .5*(X2-X1)
             Xij = X1 + DX
              if( ABS(DX) .LE. TOL ) goto 50
          else
            DXold = DX
               DX = F / DF
              old = Xij
              Xij = Xij - DX
             if( old .EQ. Xij ) goto 50
          endif
             if( ABS(DX) .LE. TOL ) goto 50
            F = FofX( Xij )
           DF = DFofX( Xij )
          if( F .LT. 0. ) then
               X1 = Xij
               F1 = F
          else
               X2 = Xij
               F2 = F
          endif

 10     CONTINUE

           write(6,*)'xSofT: exceeded maxITER, residual=', F

cd 50        write(6,51) Tij, Xij, F, ITER
cd  51       format( f8.1, 2x, f6.3, 2x, e12.2, 2x, I5 )

cd5      CONTINUE
cc.................. change weight fraction to mole fraction of B:
  50              Cij = Xij + C00
                xSofT = XX( Cij )
         return
99             write(6,*)'xSofT(T) was called with T<TA or T>TB, EXIT'
         stop
         end
