cc file  io.f  contains:  newinput.f  newlabels.f  output.f

cc#####################################################################
cc1-10-95 hardwired inputs to run without dat file on VMS
c akW(T), with void
      SUBROUTINE INPUT( tmax,maxsteps,dtout,dtouthis,dtoutprf,dtmin,
     &                  CFL,lines, Ip,Iw,Jp,Jw,Jv,
     &                  istart,Iredat,  DhfusA,DhfusB, TOL,maxITER)
c______________________________________________________________lines 48
c 6-19-93 variable akS(T) = cokS(1) + cokS(2) * ( TE - T )
c                  akL(T) = cokL(1) + cokL(2) * exp( cokL(3)*(T-1200) )
c11-13-92  Cinit as input, compute xinit from it
c 9-27-92    moved some arguments to common/size/,/init/,/weights/
c 7-28-92    added cpW  akW  akV  DL  DS  as input parameters
c 7-17-92     non-uniform Twall: straight line from Tw1 to Tbry in soil
c 7- 6-92    added DhfusDi, DhfusAn, Ttop  as input parameters
c 1-11-91    added  delta, beta  as input parameters
c10- 4-90    added void (free) space, j=0,-1,...,-Jv+1
c 6-12-89     reads in the execution parameters and the initial data
c--------
      implicit double precision (a-h,o-z)
      parameter ( Iin=5 )
      common/  size  / Rin, Rout, Zin, Zw, Zv
      common/  init  / Tinit, Tbry, Ttop, Tvoid, Tw1
      common/ weights/ WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/propts1/rho,cokL(3),cokS(2),rhoW,cpW,akW0,akW1,akV
      common/propts2/ DL,DS,delta,beta
cc................read input data:
cc read by IO.C:
c      read(Iin,*)
c      read(Iin,2) date   c   2  format(a8)
cc
cc...............read in times & timesteps, in hours.............
*      read(Iin,*) tmaxh,  maxsteps, CFL, lines, istart 
#if defined(PROFOMETER)
      call mark_profometer('green\0')
#elif defined(PERFOMETER)
      call mark_perfometer(GREEN,"IO.C")
#endif
            tmaxh    = 12.1d0
            maxsteps = 50000
            CFL    = 1.0
            lines  = 16
            istart = 0
*      read(Iin,*) dtouth, dthish, dtprfh, dtmin, Iredat 
            dtouth = 4.0
            dthish = 1.d0
            dtprfh = 240.d0
            dtmin  = 1.d-4
            Iredat = 0
cc        .......in meters..............
*      read(Iin,*) Rin, Rout, Zin, Zw, Zv
            Rin  = 1.0663d0
            Rout = 2.d0
            Zin  = 1.4d0
            Zw   = 1.d0
            Zv   = 0.5d0
*      read(Iin,*) Ip, Jp, Iw, Jw, Jv
            Ip = 64
            Jp = 64
            Iw =  6
            Jw =  6
            Jv =  4
c xinit:      read(Iin,*) Tinit, xinit
c Cinit:
*              read(Iin,*) Tinit, Cinit
            Tinit = 1404.0
            Cinit = 0.5d0
                   xinit = WA * Cinit / ( WB - Wdiff * Cinit )
*      read(Iin,*) Tbry , Ttop, Tvoid, Tw1
            Tbry = 20.0
            Ttop = 20.0
            Tvoid= 250.0
            Tw1  = 1404.0
*      read(Iin,*) rho, cokL(1),cokL(2),cokL(3), cokS(1),cokS(2) 
            rho  = 2600.0
            cokL(1) = 0.0e-4
            cokL(2) = 1.0e-2
            cokL(3) = 1.0e-1
            cokS(1) = 3.4e-3
            cokS(2) = -3.8e-6
*      read(Iin,*) rhoW, cpW,  akW0, akW1,  akV
            rhoW = 1350.0
            cpW  = 0.85
            akW0 = 3.3d-3
            akW1 = 0.	  !!strange, now akW grows expo with 6.3d-6 !
            akV  = 1.d-3
*      read(Iin,*) DL, DS,     delta, beta
            DL = 1.d-9
            DL = 1.d-13
            delta = 0.0
            beta  = 0.0
*      read(Iin,*) DhfusA, DhfusB
            DhfusA = 0.0
            DhfusB = 0.0
*      read(Iin,*) TOL , maxITER
            TOL     = 1.d-6
            maxITER = 1000
cc........to seconds:
      tmax     = tmaxh  * 3600.0
      dtout    = dtouth * 3600.0
      dtouthis = dthish * 3600.0
      dtoutprf = dtprfh * 3600.0
c*****
      return
      end


c########1#########2#########3#########4#########5#########6#########7##
      subroutine LABELS( date, Icomp,Itemp,Iprf,Iph,Irhis,Jzhis, NOhist,
     &                   Ihist,Jhist,NOtherm, idr,idz,r,z, 
     &                   xinit,  DhfusA, DhfusB,   Ip,Iw,Jp,Jw,Jv,
     &                   NsupSTEP,dampSTEP  )
c_____________________________________________________________ lines 121
c 9-26-92  labeling of output files (moved out of main.f) 
called by IO.C()
cc----------------------------------------------------------------------
                    implicit double precision (a-h,o-z)
      DIMENSION r(Ip+Iw),    z(1-Jw-Jv:Jp+Jw)
        integer idr(87), idz(87), Ihist(16), Jhist(16), NOtherm(16)
        character*8     date
c        character*24   fdate

      common/ size  / Rin, Rout, Zin, Zw, Zv
      common/ init  / Tinit, Tbry, Ttop, Tvoid, Tw1
      common/propts1/ rho,cokL(3),cokS(2),rhoW,cpW,akW0,akW1,akV
      common/propts2/ DL,DS,delta,beta
      common/switch / T32kL


cc........................labels in fort.Icomp..........................

c      write(Icomp,*)'fort.1: Mole fractions every dtoutprf,~~~',date  
c     &             ,'  at every other j'
c      write(Icomp,*)'      r(i)       z(j)        x(i,j)'
c      write(Itemp,*)'fort.2: Temperatures every dtoutprf,~~~',date  
c     &             ,'  at every other j'
c      write(Itemp,*)'      r(i)       z(j)        T(i,j)'
c      write(IrS,*)' 
c      write(Ivel,*)' 

cc........................labels in fort.Ihis...........................

  53       format('# Rin, Rout, Zin, Zw, Zv :', 5f6.2,' meters' )
  54       format('# Ip, Jp, Iw, Jw, Jv     :', 5I5,' #mesh-intervals')
  55       format('# xinit,Tinit,Tbry,Ttop,Tvoid,Tw1:',f4.2, 5f7.0 )
  56       format('# rho, cokL(1,2,3), cokS(1,2)  :',f7.1, 5(1Pe10.2) )
  561      format('# switch kL from cokL3 to cokL2 at T32kL =', f5.0  )
  57       format('# rhoW,cpW, akW0,akW1,akV:',f7.1,f6.2,1x,3(1Pe9.2))
  58       format('# DL, DS,  delta, beta   :',2(1Pe9.1), 2x, 2f8.1 )
  59       format('# DhfusA, DhfusB     :',2f8.1,' heats of fusion')
  63       format('# SUPERstepping with NsupSTEP=',I3,' damping=',f5.2 )

#if defined(PROFOMETER)
      call mark_profometer('green\0')
#elif defined(PERFOMETER)
      call mark_perfometer(GREEN,"IO.C")
#endif
         if( NOhist ) 71, 74, 76

 71         Ihis = 7
c      write(Ihis,*) '# ', fdate()
      write(Ihis,*)'#fort.7: Histories of T at thermocouples~~~~~',date
      do no = 1, -NOhist
         Nono = NOtherm(no)
cd      write(Ihis,72) NOtherm(no),idr(no),idz(no),r(idr(no)),z(idz(no))
       write(Ihis,72) NOno,idr(Nono),idz(Nono),r(idr(Nono)),z(idz(Nono))
      enddo
  72   format('#',I2,' contained in vol(i,j):',2I3,',  (r,z):',2f7.2)
          write(Ihis,*) '#____________________input data (SI units):'
          write(Ihis,53) Rin, Rout, Zin, Zw, Zv
          write(Ihis,54) Ip, Jp, Iw, Jw, Jv
          write(Ihis,55) xinit, Tinit, Tbry, Ttop, Tvoid, Tw1
          write(Ihis,56) rho, cokL(1),cokL(2),cokL(3), cokS(1),cokS(2)
          write(Ihis,561)T32kL 
          write(Ihis,57) rhoW, cpW,  akW0, akW1,  akV
          write(Ihis,58) DL, DS,  delta, beta
          write(Ihis,59) DhfusA, DhfusB
          write(Ihis,63) NsupSTEP, dampSTEP
          write(Ihis,*) '#'
      write(Ihis,73) ( NOtherm(no), no=1, 6 )
  73  format('#time(h) @therm#',I2,' @therm#',I2,' @therm#'
     &    ,I2,' @therm#',I2,' @therm#',I2,' @therm#',I2 )
      goto 80

 74         Ihis = 17
c      write(Ihis,*)'# ', fdate()
      write(Ihis,*)'#fort.17: Histories of x,T at 3 locations~~~',date
      write(Ihis,75) Irhis,Irhis,Jzhis,Irhis,Jp
     &              ,Irhis,Irhis,Jzhis,Irhis,Jp
   75 format('#time(h)    x(',I2,',1)  x(',I2,',',I2,')  x(',I2,',',I2,
     &       ')     T(',I2,',1)  T(',I2,',',I2,')  T(',I2,',',I2,')' )
      goto 80

 76         Ihis = 27
c      write(Ihis,*) '# ', fdate()
      write(Ihis,83) date
 83   format('# fort.27: Histories of T at nodes ~~~~~~~~~ ',a8 )
      DO no = 1, NOhist
      write(Ihis,77)NOtherm(no),Ihist(no),Jhist(no),r(Ihist(no)),
     &                                              z(Jhist(no))
      ENDDO
  77  format('#node#',I2,' contained in vol(i,j):',2I3,', (r,z):',2f7.2)
          write(Ihis,85)
  85      format('#____________________input data (SI units):')
          write(Ihis,53) Rin, Rout, Zin, Zw, Zv
          write(Ihis,54) Ip, Jp, Iw, Jw, Jv
          write(Ihis,55) xinit, Tinit, Tbry, Ttop, Tvoid, Tw1
          write(Ihis,56) rho, cokL(1),cokL(2),cokL(3), cokS(1),cokS(2)
c          write(Ihis,561)T32kL 
         write(Ihis,*)'# switch kL from cokL3 to cokL2 at T32kL =',T32kL
          write(Ihis,57) rhoW, cpW,  akW0, akW1,  akV
          write(Ihis,58) DL, DS,  delta, beta
          write(Ihis,59) DhfusA, DhfusB
          write(Ihis,63) NsupSTEP, dampSTEP
c          write(Ihis,*) '#'
      write(Ihis,78) ( NOtherm(no), no=1, NOhist )
  78   format('#time(h) node#',I2,' node#',I2,' node#',I2,
     &                ' node#',I2,' node#',I2,' node#',I2,
     &                ' node#',I2,' node#',I2,' node#',I2,
     &                ' node#',I2,' node#',I2,' node#',I2,
     &                ' node#',I2,' node#',I2,' node#',I2 )

80    continue
cc........................labels in fort.Iprf...........................

c      write(Iprf,*)'# fort.8: Radial Profiles: ~~~~~~',date
c      write(Iprf,88) Jzhis, Jp, Jzhis, Jp
   88 format('#  r(i)      x(i,1)    x(i,',I2,')   x(i,',I2,')',
     &                '   T(i,1)    T(i,',I2,')   T(i,',I2,')' )

cc........................labels in fort.Iph............................

          write(Iph,*)'# fort.9: phase distributions ~~~~~~~~~~~',date
          write(Iph,*) '#  ____________________input data (SI units):'
          write(Iph,53) Rin, Rout, Zin, Zw, Zv
          write(Iph,54) Ip, Jp, Iw, Jw, Jv
          write(Iph,55) xinit, Tinit, Tbry, Ttop, Tvoid, Tw1
          write(Iph,56) rho, cokL(1),cokL(2),cokL(3), cokS(1),cokS(2)
          write(Iph,561)T32kL 
          write(Iph,57) rhoW, cpW,  akW0, akW1,  akV
          write(Iph,58) DL, DS,  delta, beta
          write(Iph,59) DhfusA, DhfusB
          write(Iph,63) NsupSTEP, dampSTEP
          write(Iph,*)
          write(Iph,*)'#          3: melt    1: mushy    0: frozen'
          write(Iph,*)
      return
      end



c#####.##1#########2#########3#########4#########5#########6#########7##
c>> with void <<   20I1 in 1515 ;    For any Ip divisible by 4

       Subroutine OUTPUT( time,nsteps, 
     &                    Ip,Iw,Jp,Jw,Jv, C,x,T,e,alam,iphase, lskipz )
c______________________________________________________________lines 163
c 7- 6-92   print outs from j=1 to Jp, fo z=depth (for ISV) 
c11-16-90   moved the E,C balance to main.f
c10-6-90    added void (free) space, j=0,-1,...,-Jv+1
c 3-21-90    trying to get contours via NCAR routines, not working yet
c12-22-89    this is the basic output at each dtout in unit_6 
c---------
      implicit double precision (a-h,o-z)
      parameter (Iin=5, Iout=6, Ihis=7, Iprf=8, Iph=9, Iredat=19 )
      DIMENSION C(Ip,Jp), x(Ip,Jp), iphase(Ip+1,Jp), alam(Ip,Jp) 
      DIMENSION e(Ip+Iw,1-Jw-Jv:Jp+Jw)
      DIMENSION T(Ip+Iw+1,1-Jw-Jv:Jp+Jw+1)

      common/  init  / Tinit, Tbry, Ttop, Tvoid, Tw1

c-----------------------------------------------------------------------
#if defined(PROFOMETER)
      call mark_profometer('green\0')
#elif defined(PERFOMETER)
      call mark_perfometer(GREEN,"IO.C")
#endif
      write(Iout,*)'***************************************'
c      write(Iout,9)'Time =',time,'(s) | no of steps=',nsteps,' | Tbry='
      write(Iout,9) time, nsteps, Tbry,Ttop,Tvoid,Tw1
      write(Iph,9) time, nsteps, Tbry,Ttop,Tvoid,Tw1
  9   format('Time =',f7.2,'(h)| #steps=',I7,'| Tbry,Ttop,Tvoid,Tw1='
     &       ,2f4.0,2f5.0)
c      write(Iout,9)'Time =',time,'(h) | #steps=',nsteps,
c     &              ,Tbry,Ttop,Tvoid,Tw1
c 9    format(1x,A6,f8.2,A13,I8,' | Tbry,Ttop,Tvoid,Tw1=',4f5.1) 
      write(Iout,*)'________________________'

cc------ Formated for any Ip divisible by 4 and any Iw,Jw and Jv -------
cc    we set lskipr = Ip/4 = # of skipped columns and print columns:
cc       ( i=1) (i=lskipr,Ip,lskipr)     ( i=Ip+1 ) ( i=Ip+Iw )
cc       (axis) ( four PCM columns )     (1st wall) (last wall) 

          lskipr = Ip/4

cc----j=Jp,1:
c	     write(Iout,*) 'liquid fractions: alam, j=Jp,1',-lskipz
c          DO 1100 j=Jp,2,-lskipz
c             write(Iout,1111) alam(1,j),(alam(i,j), i=lskipr,Ip,lskipr)
c1100      CONTINUE
c             write(Iout,1111) alam(1,1),(alam(i,1), i=lskipr,Ip,lskipr)
1111              format(f12.6,4f12.6) 

cc----j=1,Jp:
	     write(Iout,*) 'liquid fractions: alam, i=1,(Ip/4,Ip,Ip/4)'
     &                    ,' j=1,Jp',lskipz
             write(Iout,1111) alam(1,1),(alam(i,1), i=lskipr,Ip,lskipr)
          DO 1100 j=2,Jp,lskipz
             write(Iout,1111) alam(1,j),(alam(i,j), i=lskipr,Ip,lskipr)
1100      CONTINUE

cc----j=Jp,1:
c	     write(Iout,*) 'mole fractions: j=Jp,1',-lskipz
c          DO 1200 j=Jp,2,-lskipz
c                 write(Iout,1111) x(1,j), ( x(i,j), i=lskipr,Ip,lskipr)
c1200      CONTINUE
c                 write(Iout,1111) x(1,1), ( x(i,1), i=lskipr,Ip,lskipr)
cc----j=1,Jp :
c	     write(Iout,*) 'mole fractions: j=1,Jp',lskipz
c                 write(Iout,1111) x(1,1), ( x(i,1), i=lskipr,Ip,lskipr)
c          DO 1200 j=2,Jp, lskipz
c                 write(Iout,1111) x(1,j), ( x(i,j), i=lskipr,Ip,lskipr)
c1200      CONTINUE

cc----j=Jp,1:
	     write(Iout,*) 'weight fractions: j=1,Jp,',lskipz
                  write(Iout,1111) C(1,1), ( C(i,1), i=lskipr,Ip,lskipr)
	  DO 1250 j= 2, Jp, lskipz
	          write(Iout,1111) C(1,j), ( C(i,j), i=lskipr,Ip,lskipr)
1250      CONTINUE
1251              format(5d14.8)
                   Ipw = Ip + Iw

cc----j=Jp+Jw, -Jv-Jw+1 :
c	  write(Iout,*) 'Temperatures: j=Jp+Jw,-Jv-Jw+1,',-lskipz
c          write(Iout,1313) T(1,Jp+Jw),(T(i,Jp+Jw),i=lskipr,Ip,lskipr),
c     &                                   T(Ip+1,Jp+Jw),T(Ipw,Jp+Jw)
c          write(Iout,1313) T(1,Jp+1), ( T(i,Jp+1),i=lskipr,Ip,lskipr),
c     &                                     T(Ip+1,Jp+1),T(Ipw,Jp+1)
c                  write(Iout,*)
c          DO 1300 j=Jp,2,-lskipz
c                  write(Iout,1313) T(1,j), (T(i,j),i=lskipr,Ip,lskipr),
c     &                                      T(Ip+1,j), T(Ipw,j)
c1300      CONTINUE
c          write(Iout,1313) T(1,1), ( T(i,1),i=lskipr,Ip,lskipr ),
c     &                                          T(Ip+1,1),T(Ipw,1)
c                  write(Iout,*)
c          write(Iout,1313) T(1,0), ( T(i,0),i=lskipr,Ip,lskipr ),
c     &                                           T(Ip+1,0),T(Ipw,0)
c          write(Iout,1313) T(1,1-Jv),( T(i,1-Jv),i=lskipr,Ip,lskipr ),
c     &                                     T(Ip+1,1-Jv),T(Ipw,1-Jv)
c                  write(Iout,*)
c          write(Iout,1313) T(1,-Jv), (T(i,-Jv),i=lskipr,Ip,lskipr),
c     &                                     T(Ip+1,-Jv),T(Ipw,-Jv)
c      write(Iout,1313)T(1,-Jv-Jw+1),(T(i,-Jw-Jv+1),i=lskipr,Ip,lskipr),
c     &                               T(Ip+1,-Jw-Jv+1),T(Ipw,-Jw-Jv+1)
 
1313              format(f10.3,4f10.3,2x,2f10.3)

cc----j= -Jv-Jw+1 , Jp+Jw :
	  write(Iout,*) 'Temperatures: i=1,(Ip/4,Ip,Ip/4)'
     &                 ,' j=1,(2,Jp,',lskipz,')'
      write(Iout,1313)T(1,-Jv-Jw+1),(T(i,-Jw-Jv+1),i=lskipr,Ip,lskipr),
     &                               T(Ip+1,-Jw-Jv+1),T(Ipw,-Jw-Jv+1)
          write(Iout,1313) T(1,-Jv), (T(i,-Jv),i=lskipr,Ip,lskipr),
     &                                     T(Ip+1,-Jv),T(Ipw,-Jv)
                  write(Iout,*)
          write(Iout,1313) T(1,1-Jv),( T(i,1-Jv),i=lskipr,Ip,lskipr ),
     &                                     T(Ip+1,1-Jv),T(Ipw,1-Jv)
          write(Iout,1313) T(1,0), ( T(i,0),i=lskipr,Ip,lskipr ),
     &                                           T(Ip+1,0),T(Ipw,0)
                  write(Iout,*)
          write(Iout,1313) T(1,1), ( T(i,1),i=lskipr,Ip,lskipr ),
     &                                          T(Ip+1,1),T(Ipw,1)
        DO 1300 j=2,Jp,lskipz
                  write(Iout,1313) T(1,j), (T(i,j),i=lskipr,Ip,lskipr),
     &                                      T(Ip+1,j), T(Ipw,j)
1300    CONTINUE
                  write(Iout,*)
          write(Iout,1313) T(1,Jp+1),(T(i,Jp+1),i=lskipr,Ip,lskipr),
     &                                   T(Ip+1,Jp+1),T(Ipw,Jp+1)
          write(Iout,1313) T(1,Jp+Jw),(T(i,Jp+Jw),i=lskipr,Ip,lskipr),
     &                                   T(Ip+1,Jp+Jw),T(Ipw,Jp+Jw)

c	     write(Iout,*) 'energies:  j=Jp+Jw,-Jw-Jv+1,',-lskipz
c	  DO 1400 j=Jp+Jw,-Jw-Jv+1,-lskipz
c	          write(Iout,1414) (e(i,j), i=1,Ip+Iw)
c1400      CONTINUE 
c1414              format(7d10.1)

cc----j=Jp,1 :
c             write(Iout,*) 'iphase : j=Jp,1,',-lskipz,'/2'
c          DO 1500 j=Jp,2, -MAX( lskipz/2, 1 ) 
c                  write(Iout,1515) ( iphase(i,j), i=1,Ip)
c1500      CONTINUE
c                  write(Iout,1515) ( iphase(i,1), i=1,Ip)

c>>>>>set # I1 equal to Ip
1515              format(1x,64I1)

cc----j=1,Jp :
             write(Iout,*) 'iphase : j=1,Jp',lskipz,'/2'
                  write(Iout,1515) ( iphase(i,1), i=1,Ip)
          DO 1500 j=2,Jp, MAX( lskipz/2, 1 ) 
                  write(Iout,1515) ( iphase(i,j), i=1,Ip)
1500      CONTINUE

          DO  j = 1, Jp
                  write(Iph,1515) ( iphase(i,j), i=1,Ip)
          ENDDO

c---DELETED: columnar output, see output5x8.f (not fixed up)----------
c---DELETED: fluxes, resistances, see output5x8.f (not fixed up)------

          write(Iout,*)'--------------------' 
c------------ check balance of energy & mass over last time-step--------
c 11-16-90    moved them to main.f

         return
         end




cc file  re.f  contains:   redata.f restart.f

c########1#########2#########3#########4#########5#########6#########7##
c with void  ( non-conducting )
      SUBROUTINE REDATA( time,nsteps,tout,dtperm,
     &                        Dr,DrW,Dz,DzW,DzV, sratioW,velMAX,
     &      drokIp,dzokJv,zkV0,zz21,ArIp,AzJv,r,r2,z,z2,Ar,Az,V,
     &      totMass, C,CL,CS,x,alam,iphase,T,e,Enew,Cnew,Ip,Iw,Jp,Jw,Jv)
c______________________________________________________________lines 102
c11- 8-90  changed void to have uniform Tvoid (rhoV=0),non-conducting
c10- 4-90    added void (free) space, j=0,-1,...,-Jv+1
c 1-21-90  saves all the values needed for RESTARTing
c        in a new file(unit_19): REdat, which should be renamed REstart
c        to be read by RESTART(), when istart=1 in the basic 'dat' file
c********
      implicit double precision (a-h,o-z)
      parameter ( Iredat=19 )
      DIMENSION   r(Ip+Iw),    z(1-Jw-Jv:Jp+Jw)
      DIMENSION  r2(Ip+Iw+1), z2(1-Jw-Jv:Jp+Jw+1)
      DIMENSION  Ar(Ip+Iw+1,1-Jw-Jv:Jp+Jw)
      DIMENSION  Az(Ip+Iw,1-Jw-Jv:Jp+Jw+1)
      DIMENSION   V(Ip+Iw,1-Jw-Jv:Jp+Jw)
      DIMENSION C(Ip,Jp), x(Ip,Jp), iphase(Ip+1,Jp)
      DIMENSION CL(Ip,Jp), CS(Ip,Jp), alam(Ip,Jp)
      DIMENSION e(Ip+Iw,1-Jw-Jv:Jp+Jw)
      DIMENSION T(Ip+Iw+1,1-Jw-Jv:Jp+Jw+1)
c***********************************************************************
c        open(Iredat,file='REdat',status='new',FORM='unformatted')
#if defined(PROFOMETER)
      call mark_profometer('green\0')
#elif defined(PERFOMETER)
      call mark_perfometer(GREEN,"IO.C")
#endif
        open(Iredat,file='REdat',status='new')
       write(Iredat,*)' file REdat, for RESTARTing  BAS2D,',
     &                '  should be renamed REstart'
       write(Iredat,*)' save:  time,nsteps,tout,dtperm :' 
             write(Iredat,*) time,nsteps,tout,dtperm
c-----------------------------save MESH data, and totMass---------------
             Ipw  = Ip + Iw
             Jpw  = Jp + Jw
             Jvw1 = Jv + Jw - 1

101            format(3e24.16)
       write(Iredat,*)' save:  Dr,DrW,Dz,DzW,DzV,sratioW,velMAX :'
             write(Iredat,*) Dr,DrW,Dz,DzW,DzV,sratioW,velMAX
       write(Iredat,*)' save:  drokIp,dzokJv,zkV0,zz21,ArIp,AzJv,totM :'
             write(Iredat,*) drokIp,dzokJv,zkV0,zz21,ArIp,AzJv,totMass
       write(Iredat,*)' save:  r(i), i=1,Ip+Iw :' 
             write(Iredat,101) ( r(i), i=1,Ipw ) 
       write(Iredat,*)' save:  r2(i), i=1,Ip+Iw+1 :' 
             write(Iredat,101) ( r2(i), i=1,Ipw+1 ) 
       write(Iredat,*)' save:  z(j), j=-Jv-Jw+1, Jp+Jw :' 
             write(Iredat,101) ( z(j), j=-Jvw1, Jpw ) 
       write(Iredat,*)' save:  z2(j), j=-Jv-Jw+1, Jp+Jw+1 :' 
             write(Iredat,101) ( z2(j), j=-Jvw1, Jpw+1 ) 
       write(Iredat,*)
     &       ' save:  Ar(i,j), i=1,Ip+Iw+1, j=-Jv-Jw+1, Jp+Jw '  
         DO 100 j=-Jvw1, Jpw
             write(Iredat,101) ( Ar(i,j), i=1,Ipw+1 )   
100      CONTINUE
       write(Iredat,*)' save:  Az(i,j), i=1,Ip+Iw, j=-Jv-Jw+1,Jp+Jw+1'  
         DO 120 i=1, Ipw
             write(Iredat,101) ( Az(i,j), j=-Jvw1, Jpw+1 )  
120      CONTINUE
       write(Iredat,*)' save:  V(i,j), i=1,Ip+Iw, j=-Jv-Jw+1,Jp+Jw :' 
         DO 150 j=-Jvw1, Jpw
             write(Iredat,101) ( V(i,j), i=1,Ipw )
150      CONTINUE
c-------------------------save C,CL,CS,x,alam,iphase-------------------
       write(Iredat,*)' save  C(i,j), i=1,Ip :'
       DO 200 j=1, Jp
              write(Iredat,101) ( C(i,j), i=1,Ip ) 
200    CONTINUE 
       write(Iredat,*)' save  CL(i,j), i=1,Ip :'
       DO 300 j=1, Jp
              write(Iredat,101) ( CL(i,j), i=1,Ip )  
300    CONTINUE  
       write(Iredat,*)' save   CS(i,j), i=1,Ip :'
       DO 400 j=1, Jp
              write(Iredat,101) ( CS(i,j), i=1,Ip )  
400    CONTINUE  
       write(Iredat,*)' save   x(i,j), i=1,Ip :'
       DO 500 j=1, Jp
              write(Iredat,101) ( x(i,j), i=1,Ip )  
500    CONTINUE  
       write(Iredat,*)' save   alam(i,j), i=1,Ip :'
       DO 600 j=1, Jp
              write(Iredat,101) ( alam(i,j), i=1,Ip )  
600    CONTINUE  
       write(Iredat,*)' save   iphase(i,j), i=1,Ip :'
       DO 700 j=1, Jp
              write(Iredat,701) ( iphase(i,j), i=1,Ip )  
700    CONTINUE  
701            format(8I2)
c-------------------------------save T, e ------------------------------
       write(Iredat,*)' T(i,j), i=1,Ip+Iw, j=-Jv-Jw+1,Jp+Jw :'   
       DO 800 j=-Jvw1, Jpw
              write(Iredat,101) ( T(i,j), i=1,Ipw ) 
800    CONTINUE 
       write(Iredat,*)' e(i,j), i=1,Ip+Iw, j=-Jv-Jw+1,Jp+Jw :'   
       DO 900 j=-Jvw1, Jpw
              write(Iredat,101) ( e(i,j), i=1,Ipw ) 
900    CONTINUE 
c-------------------------------save Enew, Cnew ------------------------
              write(Iredat,*) Enew, Cnew
              close(Iredat)
       return
       end



c#####.##1#########2#########3#########4#########5#########6#########7##
c with void  ( non-conducting )
      SUBROUTINE RESTART(time,nsteps,tout,dtperm,
     &                        Dr,DrW,Dz,DzW,DzV, sratioW,velMAX,
     &      drokIp,dzokJv,zkV0,zz21,ArIp,AzJv,r,r2,z,z2,Ar,Az,V,
     &      totMass, C,CL,CS,x,alam,iphase,T,e,Eold,Cold,Ip,Iw,Jp,Jw,Jv)
c______________________________________________________________lines 95
c11- 8-90  changed void to have uniform Tvoid (rhoV=0),non-conducting
c10- 4-90    added void (free) space, j=0,-1,...,-Jv+1
c 1-21-90  reads in all the values needed for RESTARTing 
c          from file "REstart" (renamed from dropfile "REdat")
c          when istart=1 in basic DAT file 
c********
      implicit double precision (a-h,o-z) 
      parameter ( Istart = 11 ) 
      DIMENSION   r(Ip+Iw),    z(1-Jw-Jv:Jp+Jw)
      DIMENSION  r2(Ip+Iw+1), z2(1-Jw-Jv:Jp+Jw+1)
      DIMENSION  Ar(Ip+Iw+1,1-Jw-Jv:Jp+Jw)
      DIMENSION  Az(Ip+Iw,1-Jw-Jv:Jp+Jw+1)
      DIMENSION   V(Ip+Iw,1-Jw-Jv:Jp+Jw)
      DIMENSION C(Ip,Jp), x(Ip,Jp), iphase(Ip+1,Jp)
      DIMENSION CL(Ip,Jp), CS(Ip,Jp), alam(Ip,Jp)
      DIMENSION e(Ip+Iw,1-Jw-Jv:Jp+Jw)
      DIMENSION T(Ip+Iw+1,1-Jw-Jv:Jp+Jw+1)
c**************
c           open(Istart,file='restart',status='old',FORM='unformatted')
#if defined(PROFOMETER)
      call mark_profometer('green\0')
#elif defined(PERFOMETER)
      call mark_perfometer(GREEN,"IO.C")
#endif
            open(Istart,file='REstart',status='old')
101                  format(3e24.16)
       read(Istart,*)
       read(Istart,*)
            read(Istart,*) time,nsteps,tout,dtperm
       read(Istart,*) 
            read(Istart,*) Dr,DrW,Dz,DzW,DzV,sratioW 
       read(Istart,*) 
            read(Istart,*) drokIp,dzokJv,zkV0,zz21,ArIp,AzJv,totMass
       read(Istart,*)
       read(Istart,101) ( r(i), i=1,Ip+Iw ) 
       read(Istart,*) 
            read(Istart,101) ( r2(i), i=1,Ip+Iw+1 ) 
       read(Istart,*) 
            read(Istart,101) ( z(j), j=-Jw-Jv+1, Jp+Jw )
       read(Istart,*)  
            read(Istart,101) ( z2(j), j=-Jw-Jv+1, Jp+Jw+1 )
       read(Istart,*)   
	 DO 100 j=-Jw-Jv+1, Jp+Jw
            read(Istart,101) ( Ar(i,j), i=1,Ip+Iw+1 ) 
100      CONTINUE
       read(Istart,*)   
         DO 120 i=1, Ip+Iw
            read(Istart,101) ( Az(i,j), j=-Jw-Jv+1, Jp+Jw+1 )
120      CONTINUE
       read(Istart,*)
       DO 150 j=-Jw-Jv+1, Jp+Jw
              read(Istart,101) ( V(i,j), i=1,Ip+Iw )
150    CONTINUE
c-------------------------read C,CL,CS,x,alam,iphase------------------- 
       read(Istart,*)
       DO 200 j=1, Jp   
              read(Istart,101) ( C(i,j), i=1,Ip )
200    CONTINUE 
       read(Istart,*)
       DO 300 j=1, Jp
              read(Istart,101) ( CL(i,j), i=1,Ip )
300    CONTINUE  
       read(Istart,*)
       DO 400 j=1, Jp
              read(Istart,101) ( CS(i,j), i=1,Ip )
400    CONTINUE  
       read(Istart,*)
       DO 500 j=1, Jp    
              read(Istart,101) ( x(i,j), i=1,Ip )
500    CONTINUE  
       read(Istart,*)
       DO 600 j=1, Jp
              read(Istart,101) ( alam(i,j), i=1,Ip )
600    CONTINUE  
       read(Istart,*)
       DO 700 j=1, Jp
              read(Istart,701) ( iphase(i,j), i=1,Ip )
700    CONTINUE 
701            format(8I2)
c-------------------------------read T, e ------------------------------
       read(Istart,*)
       DO 800 j=-Jw-Jv+1, Jp+Jw
              read(Istart,101) ( T(i,j), i=1,Ip+Iw )
800    CONTINUE
       read(Istart,*)
       DO 900 j=-Jw-Jv+1, Jp+Jw
              read(Istart,101) ( e(i,j), i=1,Ip+Iw )
900    CONTINUE
c-------------------------------- read Eold, Cold ----------------------
             read(Istart,*) Eold, Cold
             close(Istart)
       return
       end
