c########1###########################################################7##
c with void (non-conducting)
c Fs-Px 

      SUBROUTINE PHASE(C,e,Tinit,Ip,Iw,Jp,Jw,Jv,Dr,TOL,maxITER,maxNeMev,
     &     nsteps, Tbry,Tvoid,  Ar,Az,ArIp,AzJv,drokIp,dzokJv,zkV0,zz21,
     &             akWmax,       x,T,alam,alamold,CL,CS,iphase,RS,RSold) 
c______________________________________________________________lines 204
c11-7-92  Fs-Px version ( non-eutectic )
c 7- 6-92 split off Tvoid as external function TinVOID()
c         trying to simulate open-top cylinder by imposing Tvoid
c         seems to work ( Ebalance is off since loss to void not counted
c 6-17-92 modified for Diopside-Anorthite
c11-18-90 added r-location of Solidus(RS), for velocity output in main()
c 11-7-90  changed void to NON-CONDUCTING (rhoV=0), uniform Tvoid 
c10- 4-90    added void (free) space, j=0,-1,...,-Jv+1, CONDUCTING 
c 4-23-90  new ZEROeL() solver (instead of ZEROINeL )
c 4- 7-90  new fitting of cpL, new cpLintg, solve eL=F by ZEROINeL   
c 1-19-90  using ZEROIN solver in mushy, works !!! first complete run !
c12-18-89        updates T,alam,CL,CS,iphase, from  C and e
Calls externals xLofT,TLofx, xSofT,TSofx, eLQDS,eSLDS, TinSOL,TinMUSH
c inputs: C,e  from PDE(); cpW,akV from MAIN (data statement)
c         Tinit needed for ZEROeL(liquid case), Dr for RSolidus 
c         Ar,Az,ArIp,AzJv,drokIp,dzokJv,zkV0,zz21 needed for Tvoid
c outputs:x,T,alam,CL,CS,iphase, RS,RSold (for Solidus velocity),akWmax
c--------
               implicit double precision (a-h,o-z)
      DIMENSION C(Ip,Jp), x(Ip,Jp), iphase(Ip+1,Jp),  RS(Jp),RSold(Jp) 
      DIMENSION CL(Ip,Jp), CS(Ip,Jp), alam(Ip,Jp),alamold(Ip,Jp)
      DIMENSION e(Ip+Iw,1-Jv-Jw:Jp+Jw)
      DIMENSION T(Ip+Iw+1,1-Jv-Jw:Jp+Jw+1)
      DIMENSION Ar(Ip+Iw+1,1-Jw-Jv:Jp+Jw)
      DIMENSION Az(Ip+Iw,1-Jw-Jv:Jp+Jw+1)

      common/weights/ WA,WB,Wdiff, TA,TB, xE,TE,Tref,DhfusE,xinit
      common/propts1/rho,cokL(3),cokS(2),rhoW,cpW,akW0,akW1,akV
c      common/propts2/ DL,DS,delta,beta

       EXTERNAL  xLofT, TLofx, xSofT, TSofx,  eLQDS, eSLDS, cpL 
     &          ,TinSOL, TinMUSH  

cc********************* define FUNCTIONS *******************************

cc.....to translate C=weight fraction to x=mole fraction  B.....
           XX( Cij ) = WA * Cij / ( WB - Wdiff * Cij )
cc.....to translate x=mole fraction to C=weight fraction  B.....
           CC( xij ) = WB * xij / ( WA + Wdiff * xij )

cc.....................to find the formula weight.......................
           WM( xij ) = WA + Wdiff * xij

cc.......... Liquidus curve is defined via EXTERNAL FUNCTIONS
cc         xLofT( T )  and  TLofx( x ), invere of each other
cc.........Liquidus energy eLIQUIDUS(x)=eL(x,TL(x)).... EXTERNAL.......
cc         eLQDS(x)= DhfusE+ cpLintg(xE,TE,TL(x)) + hhLintg(xE,x,TL(x))
cc.......... Solidus curve is defined via EXTERNAL FUNCTIONS
cc         xSofT( T )  and  TSofx( x ), invere of each other
cc..................solidus energy eSOLIDUS(x) .........EXTERNAL.......
cc         eSLDS( x ) = hhSintg(xE,x,TE) + cpSintg(xE,TE, TS(x)) 

cc------------------ formula for variable akW ------------------
c version 1: akW( Tij )= akW0 * ( 1. + akW1 * ( Tij - Tbry ) )
c version 2:  
             akW( Tij )= akW0  + akW1 * ( Tij - Tbry )

cc*******find the phase and Temperature of each node in the alloy*******
c                  rsdlMAX  = 0.d0
c  from dat via arguments:  TOL = 1.d-6,   maxITER  = 10000
                  TOLphase = TOL * TOL
                   NeMeval = 0

#if defined(PROFOMETER)
       call mark_profometer('cyan\0')
#elif defined(PERFOMETER)
       call mark_perfometer(CYAN,"PHASE.F")
#endif
       DO 100    j = 1, Jp
cc.              ................ save RSolidus:
c                                  RSold(j) = RS(j)
	  DO 150 i = Ip, 1, -1

                 alamold(i,j)=alam(i,j)
                 eij = e(i,j)
                 Cij = C(i,j)
  	         xij = XX( Cij )
              x(i,j) = xij
                Wxij = WM( xij )
cc..       ...........solidus Temperature from EXTERNAL TSofx()...
                TSij = TSofx( xij )
cc..       ...........liquidus Temperature from EXTERNAL TLofx()...
                TLij = TLofx( xij )
cc..       ...........solidus energy eSOLIDUS(x)......EXTERNAL....
        eSxTSij = eSLDS( xij )
cc..       ...........liquidus energy eLIQUIDUS(x)....EXTERNAL........
        eLxTLij = eLQDS( xij ) 

cc--SOLID ? ---------------------- test if it is a solid phase ---------
           emeSij = eij - eSxTSij

        IF ( emeSij .LT. TOLphase ) THEN
cc--   -------------------------------- s o l i d   c a s e ------------
cc     .......solve for T the equation cpSintg(x,T) + eSxTSij = eij.....
cc     .......try Newton, via external TinSOL(): start with old T:
              Tij = MIN( T(i,j), TSij )
              Tij = TinSOL( Tij, xij, TSij, emeSij, TOL, maxITER )
cc           ...........................check it out:
             if( Tij .LE. TSij ) goto 160
           write(6,*)'TinSOL found T>TSij at nsteps=',nsteps
     &              ,' i,j:',i,j,' EXITING'
           stop
  160          T(i,j) = Tij
            alam(i,j) = 0.d0
          iphase(i,j) = 0
              CL(i,j) = 0.d0
              CS(i,j) = C(i,j)
cc     ..........................set RSolidus(j) = left face............
c                RS(j) = (i-1)*Dr 

         ELSE IF  ( eij  .LT.  eLxTLij - TOLphase ) THEN

cc--MUSHY ? -------------------- m u s h y   c a s e ------------------

cc...     ........solve eM(xij,Tij)-eij = 0 for Tij inside [TSij,TLij] 
cc...     ........using TinMUSH.f, count No. of evaluations.....

          Tij = TinMUSH(   TSij,    TLij, TOL, eij, xij, 
     &                  eSxTSij, eLxTLij, NeMeval )
c                  write(Iout,*)' No. of eM() evaluations =', NeMeval
                maxNeMev = MAX( NeMeval, maxNeMev )
 	        T(i,j) = Tij
	         xSTij = xSofT( Tij )
	         xLTij = xLofT( Tij )
	     alam(i,j) = ( xij - xSTij ) / ( xLTij - xSTij )
	   iphase(i,j) = 1
               CL(i,j) = CC( xLTij )
               CS(i,j) = CC( xSTij )
cc..    ................find RSolidus(j)=radial location of the Solidus:
c               if( iphase(i+1,j) .EQ. 0 ) then
c                   elam  = ( eij - eSxTSij ) / ( eLxTLij - eSxTSij )
c                   RS(j) = ( i-1 + elam ) * Dr
c               endif

          ELSE
c--LIQUID ! ----------------- l i q u i d   c a s e -------------------
cc      ......solve for T from  cpLintg(x,TLij,T) + eLxTLij = eij......
cc      ......by hand, since it is a linear in T:
                   Fij = eij - eLxTLij 
                 cpLij = cpL( xij, TLij )
                Tij    =  TLij + Fij / cpLij
95              T(i,j) = Tij
	     alam(i,j) = 1.d0
	   iphase(i,j) = 3
               CL(i,j) = Cij
               CS(i,j) = 0.d0

        END IF 

  150     CONTINUE
100    CONTINUE

c********************** update T(i,j) in the walls *********************
cc new                 and find akWmax for next sratioW
         akWmax = 0.0
                 Jv1 = -Jv+1
         DO 200    j = 1, Jw
	    DO 250 i = 1, Ip + Iw
	                   Tij = Tref + e(i,Jv1-j) / cpW
	            T(i,Jv1-j) = Tij
                        akWij = akW( Tij )
                       akWmax = MAX( akWij, akWmax )
	                  Tij = Tref + e(i,Jp+j) / cpW
	            T(i,Jp+j) = Tij
                        akWij = akW( Tij )
                       akWmax = MAX( akWij, akWmax )
  250       CONTINUE
200      CONTINUE
c-------------------------and in the lateral wall-----------------------
	 DO 300    j = -Jv+1, Jp
	    DO 350 i = Ip +1, Ip + Iw
	                  Tij = Tref + e(i,j) / cpW
	               T(i,j) = Tij
                        akWij = akW( Tij )
                       akWmax = MAX( akWij, akWmax )
  350        CONTINUE
300      CONTINUE

c********************** update T(i,j) in the void **********************
cc 7-6-92  made it into an EXTERNAL FUNCTION

c       Tvoid = TinVOID( T,alam, Ip,Iw,Jp,Jw,Jv,Dr, 
c     &                       Ar,Az,ArIp,AzJv,drokIp,dzokJv,zkV0,zz21 )
 
cc------------------ now update T(i,j) in the void ---------------------
cc---To simulate an open top, use a thin void and impose Tvoid (<dat)
cc                                                ~~~~~~
        do 500  j = -Jv+1, 0
          do 550  i = 1, Ip
              T(i,j) = Tvoid
  550     continue
500     continue
cc                          DONE !
              return
               end

