cc cpS=cpL version for noheats

cc file properties.f contains:

cc file  cp.f  contains:  cpL.f, cpLintg.f,  cpS.f, cpSintg.f
cc                         kL.f, kS.f
cc file  h.f  contains:  hL.f  hhLintg.f   hS.f  hhSintg.f

c########1#########2#########3#########4#########5#########6#########7##
c Fs-Px 

      FUNCTION cpL( xij, T1 ) 
c_____________________________________________________________ lines  24
c 2-17-93   new FsPx properties
computes.......cpL(x,T1) = cpL(x,T)....
called by: PROFLUX()
c inputs:  T1 , xij ( => Wxij = molweight at xij )
c outputs: cpL  (kJ/kg)
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/ coefs / coCpS(7), coCpL(3), cohL(6), cohhLig(6)
cc BLOCK DATA coCpL/ 417.d0,  358.6d0,  0.0 /
c--------
cd                   T1K = T1 + 273.15d0
cd                   T2K = T2 + 273.15d0
                   Wxij = WA + Wdiff * xij
            CpLxij = (1.-xij) * coCpL(1) + xij * coCpL(2)
            cpL    =  CpLxij / Wxij
99    return
      end

c########1###########################################################7##
c Fs-Px 

      FUNCTION cpLintg( xij, T1, T2 ) 
c_____________________________________________________________ lines  23
c 2-17-93  new FsPx properties
computes.......cpLintg(x,T1,T2) = integral(cpL(x,s)ds)(T1 to T2)....
called by: START(), PHASE()
c inputs:  T1, T2, xij ( => Wxij = molweight at xij )
c outputs: cpLintg  (kJ/kg)
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/ coefs / coCpS(7), coCpL(3), cohL(6), cohhLig(6)
cc BLOCK DATA coCpL/ 417.d0,  358.6d0,  0.0 /
c--------
cd                   T1K = T1 + 273.15d0
cd                   T2K = T2 + 273.15d0
                   Wxij = WA + Wdiff * xij
            CpLxij  = (1.-xij) * coCpL(1) + xij * coCpL(2)
            cpLintg = ( T2 - T1 ) * CpLxij / Wxij
99    return
      end


c########1###########################################################7##
c Fs-Px

      FUNCTION cpS( xij , Tij )
c_____________________________________________________________ lines  24
c 2-14-93 interchanged A and B, A=Fs=An, B=Px=Di !
computes.......cpS(xij,Tij) = heat capacity of solid at (x,T) 
called by: solverS() thru PHASE() and by PROFLUX()
c inputs:  xij, Tij, Wxij (formula weight)
c output:  cpS  (kJ/kg K)
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/ coefs / coCpS(7), coCpL(3), cohL(6), cohhLig(6)
cc BLOCK DATA coCpS/ 439.37d0, -3734.1d0, -317.02d6,
cc     &             305.41d0, -1604.9d0, -7.166d6, 921.84d6 /
c--------
cpS=cpL version: set cpS = cpL:
	EXTERNAL cpL

cpS=cpL>		Wxij = WA + Wdiff * xij
cpS=cpL>                    TK = Tij + 273.15d0
cpS=cpL>                sqrtTK = SQRT( TK )
cpS=cpL>        CpSA = coCpS(1) + coCpS(2)/sqrtTK + coCpS(3) / ( TK**3 )
cpS=cpL>          CpSB = coCpS(4) + coCpS(5)/sqrtTK 
cpS=cpL>          CpSB = CpSB + ( coCpS(6) + coCpS(7) / TK ) / ( TK*TK )
cpS=cpL>            cpS  =  ( (1.-xij) * CpSA + xij * CpSB ) / Wxij 

                   Wxij = WA + Wdiff * xij
            CpLxij = (1.-xij) * coCpL(1) + xij * coCpL(2)
            cpLij  =  CpLxij / Wxij
           cpS   = cpLij
      return
      end

c########1###########################################################7##
c Fs-Px

      FUNCTION cpSintg( xij , T1 , T2 )
c_____________________________________________________________ lines  30
c 7-4-92       changed from cpSintg(x,T,W(x)) to cpSintg(x,T1,T2)
c 2-14-93 interchanged A and B, A=Fs=An, B=Px=Di !
computes.......cpSintg(x,T1,T2) = integral(cpS(x,s)ds)(T1 to T2)....
called by: eM() thru TinMUSH() thru PHASE()
c inputs:  xij, T1, T2
c output:  cpSintg  (kJ/kg)
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/ coefs / coCpS(7), coCpL(3), cohL(6), cohhLig(6)
c--------
cpS=cpL version for noheats, set cpSintg=cpLintg:
        EXTERNAL cpLintg
cpS=cpL>                 Wxij = WA + Wdiff * xij
cpS=cpL>                  T1K = T1 + 273.15d0
cpS=cpL>                  T2K = T2 + 273.15d0
cpS=cpL>                 T21K = T2 - T1
cpS=cpL>               sqrt21 = SQRT( T2K ) - SQRT( T1K )
cpS=cpL>                 oT21 = 1./T2K - 1./T1K
cpS=cpL>               oT21sq = 1./(T2K*T2K) - 1./(T1K*T1K)
cpS=cpL>     CpSigA = coCpS(1)*T21K+2*coCpS(2)*sqrt21-.5*coCpS(3)*oT21sq
cpS=cpL>        CpSigB = coCpS(4)*T21K + 2*coCpS(5)*sqrt21 
cpS=cpL>     CpSigB =   CpSigB - coCpS(6)*oT21 - .5 * coCpS(7) * oT21sq
cpS=cpL>     cpSintg = ( ( 1. - xij ) * CpSigA + xij * CpSigB ) / Wxij

                   Wxij = WA + Wdiff * xij
            CpLxij  = (1.-xij) * coCpL(1) + xij * coCpL(2)
            cpLig = ( T2 - T1 ) * CpLxij / Wxij
             cpSintg = cpLig
      return
      end


c########1###########################################################7##
c for Fs-Px

      FUNCTION akL( Tij )
c______________________________________________________________lines 15 
c 6-19-93 finds akL(T) = cokL(1) + cokl(2) * exp( cokL(3)*(T-1200) )
called by: PROFLUX(), solveT()

                implicit double precision (a-h,o-z)
      common/propts1/rho,cokL(3),cokS(2),rhoW,cpW,akW0,akW1,akV
      common/switch /T32kL

c too slow    akL = cokL(1) + cokL(2) * EXP( cokL(3) * (Tij - T32kL) )

c try piecewise constant:  1230.9 = TL( C=.5 ),  813.1 = TS
      if( Tij .GE. T32kL ) then
            akL = cokL(3)
      elseif ( Tij .GE. 813.1 ) then
            akL = cokL(2)
      else
            akL = cokL(1)
cd            write(27,*) '>>> akL  evaluated for T < 813.1 !!!'
      endif

      return
      end


c########1###########################################################7##
c for Fs-Px

      FUNCTION akS( Tij )
c______________________________________________________________lines 16 
c 6-19-93 variable akS(T) = cokS(1) + cokS(2) * ( TE - T ) 
called by: PROFLUX(), solveT()

                implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/propts1/rho,cokL(3),cokS(2),rhoW,cpW,akW0,akW1,akV

          akS = cokS(1) + cokS(2) * ( TE - Tij )

      return
      end

cc file  h.f  contains:  hL.f  hhLintg.f   hS.f  hhSintg.f

cc#######1#########2#########3#########4#########5#########6#########7##
c Fs-Px
        FUNCTION hL( xij, Tij )
cc____________________________________________________________ lines  61
c 7-1-93  noheats version
c 6-24-93     newer yet cohLGh's from Gary of 6-24-93
c 6-12-93     newest fit from Gary of 3-22-93 (ATAN instead of sqrt)
c 3-12-93     corrected new properties
c 2-19-93 new thermo properties, using Ghiorso's MELTS for hLGh
c 7-4-92, 2-14-93 corrected for  AB = FsPx , old properties
computes............hL(x,T) = hLB(x,T) - hLA(x,T)
called by: PROFLUX() 
calls    : external functions cpLintg, TLofx, cpL
c inputs:  xij, Tij 
c outputs: hL  (J/g)
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/constant/ DhfusA, DhfusB, h0SA, h0SB, eS0TE, eS1TE
      dimension cohLGh(5)
c3-12-93  DATA cohLGh / -13568., -.1491, .1613, -.0487, 1.d1 /
          DATA cohLGh / -13000., -.5408, .3663, +.0025, 1.d6 /
cc.........make sure coTL's match those in phdiag.f :
      DATA coTL1/ 0.3363d0 /, coTL2/ -0.3887d0 /,  coTL3/ 0.2576d0 /
          EXTERNAL cpLintg, TLofx, cpL
cc-------
             CC( xij ) = WB * xij / ( WA + Wdiff * xij )

             x0 = 0.0
             x1 = 1.0
                  h0LA = h0SA + DhfusA
                  h0LB = h0SB + DhfusB
               h0LAofT = h0LA + cpLintg( x0, TA, Tij )
               h0LBofT = h0LB + cpLintg( x1, TB, Tij )
               h0LBA = h0LBofT - h0LAofT
c>noheats>            Cij = CC( xij )
cd      if( Cij .EQ. 0.0 ) then
cd                             hL = h0LBA
cd      else
c>noheats>                 TLCij = TLofx( xij )
c>noheats>              h0LAofTL = h0LA + cpLintg( x0, TA, TLCij )
c>noheats>              h0LBofTL = h0LB + cpLintg( x1, TB, TLCij )
c>noheats>              h0LBATL = h0LBofTL - h0LAofTL
cd ? is h0LBA - h0LBATL = cpLigBA ?
cd          cpLigBA = cpLintg(x1, TLCij, Tij) - cpLintg(x0, TLCij, Tij)
c>noheats>              cpLATL = cpL( x0, TLCij )
c>noheats>              cpLBTL = cpL( x1, TLCij )
c>noheats>          dhdT    = ( 1. - Cij ) * cpLATL  +  Cij * cpLBTL
c>noheats>          dTLdCij = TA * ( coTL1/(1.+ Cij*Cij )
c>noheats>     &                       + coTL2 + coTL3/(.1 + Cij ) )
cc       .............formula for d/dC of hL_Ghiorso(C):
c>noheats>          dhLGhdC = cohLGh(1)*( cohLGh(2)/(1.+ Cij*Cij )
c>noheats>     &        + cohLGh(3) + cohLGh(4)/(Cij + 1./cohLGh(5)) )

c>noheats>             hL = h0LBA - h0LBATL - dhdT * dTLdCij + dhLGhdC
            hL = h0LBA
cd             hL = cpLigBA - dhdT * dTLdCij + dhLGhdC

cd       endif
c h=0:
c      hL = 0.
         return
         end 

cc#######1#########2#########3#########4#########5#########6#########7##
c Fs-Px
        FUNCTION hhLintg( x11, x22, Tij )
cc____________________________________________________________ lines  30
c 7-1-93  noheats version
c 6-24-93     newer yet cohLGh's from Gary of 6-24-93
c 6-12-93       newest fit from Gary of 3-22-93 (ATAN instead of sqrt)
c 2-19-93 new thermo properties, using Ghiorso's MELTS for hLGh
computes.......hhLintg(x,T) = integral(hL(C,T)dC)(C1 to C2)....
called by: PHASE() 
calls    : external functions cpLintg, TLofx
c inputs:  x1, x2, Tij 
c outputs: hhLintg 
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/constant/ DhfusA, DhfusB, h0SA, h0SB, eS0TE, eS1TE
      dimension cohLGh(5)
c3-12-93  DATA cohLGh / -13568., -.1491, .1613, -.0487, 1.d1 /
          DATA cohLGh / -13000., -.5408, .3663, +.0025, 1.d6 /
       EXTERNAL cpLintg, TLofx
c-------
             CC( xij ) = WB * xij / ( WA + Wdiff * xij )
cc      .............formula for hL_Ghiorso(C):
c>noheats>        hLGh( Cij ) =   cohLGh(1)*( 1. + cohLGh(2)*ATAN(Cij)
c>noheats>     &    + cohLGh(3)*Cij + cohLGh(4)*LOG(1.+cohLGh(5)*Cij) )

c>noheats>              C1 = CC( x11 )
c>noheats>              C2 = CC( x22 )
c>noheats>              x0 = 0.d0
c>noheats>              x1 = 1.d0
c>noheats>                   h0LA = h0SA + DhfusA
c>noheats>                   h0LB = h0SB + DhfusB
c>noheats>         h0LAofT = h0LA + cpLintg( x0, TA, Tij )
c>noheats>         h0LBofT = h0LB + cpLintg( x1, TB, Tij )

c>noheats>            TLC1 = TLofx( x11 )
c>noheats>        h0LAofTL = h0LA + cpLintg( x0, TA, TLC1 )
c>noheats>        h0LBofTL = h0LB + cpLintg( x1, TB, TLC1 )
c>noheats>          h0LAT1 = h0LAofT - h0LAofTL
c>noheats>          h0LBT1 = h0LBofT - h0LBofTL
c>noheats>          hLGhC1 = hLGh( C1 )
c>noheats>      tothLC1 = (1.-C1) * h0LAT1 + C1 * h0LBT1 + hLGhC1

c>noheats>            TLC2 = TLofx( x22 )
c>noheats>        h0LAofTL = h0LA + cpLintg( x0, TA, TLC2 )
c>noheats>        h0LBofTL = h0LB + cpLintg( x1, TB, TLC2 )
c>noheats>          h0LAT2 = h0LAofT - h0LAofTL
c>noheats>          h0LBT2 = h0LBofT - h0LBofTL
c>noheats>          hLGhC2 = hLGh( C2 )
c>noheats>      tothLC2 = (1.-C2) * h0LAT2 + C2 * h0LBT2 + hLGhC2

c>noheats>      hhLintg = tothLC2 - tothLC1
          hhLintg = 0.
       return
       end 

c########1#########2#########3#########4#########5#########6#########7##
c Fs-Px 
        FUNCTION hS( xij , Tij ) 
c_____________________________________________________________ lines  22
c 7-1-93  noheats version
c 6-24-93      newer yet cohSGh's from Gary of 6-24-93
c 6-12-93       newest fit from Gary of 3-22-93 (ATAN instead of sqrt)
c 2-26-93  new formula for hS(C,T)
computes hS(C,T) = hSB-hSA = [h0SB(T)-h0SA(T)]-[h0SB(TS(C))-h0SA(TS(C))]
cc        -[(1-C)(d/dT)(h0SA(T))+C(d/dT)(h0SB(T))]@(T=TS(C))*(dTS(C)/dC)
cc        + (d/dC)(hSGhiorso(C))
called by: PROFLUX()
calls    : external functions cpSintg, TSofx, cpS
c input:  Tij in degC
c output: hS (J/g)
                      implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/constant/ DhfusA, DhfusB, h0SA, h0SB, eS0TE, eS1TE
      dimension cohSGh(5)

c>> newest coefficients from Gary, 3-22-93
c 'H,FsPx,gh (kJ/kg)' = co1 * ( 1 + co2 * ATAN('X,Px,sol' -0.5)
c           + co3*('X,Px,sol' - 0.5) + co4*ln(1+co5*('X,Px,sol' - 0.5)))
c3-12-93   DATA cohSGh / -14179.d0, -.8091, .8288, -.0066, 1.d6 /
           DATA cohSGh / -13633.d0, -.1021, .1721, -.0097, 1.d3 /
cc.........make sure coTS's match those in phdiag.f :
       DATA coTS1/0.5242d0/, coTS2/-0.6479d0/, coTS3/0.1458d0/
       EXTERNAL cpSintg, TSofx, cpS
c------
             CC( xij ) = WB * xij / ( WA + Wdiff * xij )

                    x0 = 0.d0
                    x1 = 1.d0
               h0SAofT = h0SA + cpSintg( x0, TA, Tij )
               h0SBofT = h0SB + cpSintg( x1, TB, Tij )
         h0SBA = h0SBofT - h0SAofT

c>noheats>           C00 = .5d0
c>noheats>           Cij = CC( xij )
c>noheats>          CmC0 = Cij - C00
c>noheats>      if( CmC0 .LE. 0.0 ) then
c>noheats>                              hS = h0SBA
c>noheats>      else
c>noheats>                 TSCij = TSofx( xij )
c>noheats>              h0SAofTS = h0SA + cpSintg( x0, TA, TSCij )
c>noheats>              h0SBofTS = h0SB + cpSintg( x1, TB, TSCij )
c>noheats>         h0SBATS = h0SBofTS - h0SAofTS
cd          cpSigBA = cpSintg(x1, TSCij, Tij) - cpSintg(x0, TSCij, Tij)
c>noheats>              cpSATS = cpS( x0, TSCij )
c>noheats>              cpSBTS = cpS( x1, TSCij )
c>noheats>         dhdT    = (1. - Cij) * cpSATS + Cij * cpSBTS
c>noheats>         dTSdCij = TA * ( coTS1/(1.+ CmC0*CmC0 )
c>noheats>     &                   + coTS2 + coTS3/(.01+ CmC0 ) )
cc       .............formula for d/dC of hS_Ghiorso(C):
c>noheats>         dhSGhdC =  cohSGh(1)*( cohSGh(2)/(1.+ CmC0*CmC0 )
c>noheats>     &       + cohSGh(3) + cohSGh(4)/(CmC0 + 1./cohSGh(5)) )

c>noheats>              hS = h0SBA - h0SBATS - dhdT * dTSdCij + dhSGhdC
cd              hS = cpSigBA - dhdT * dTSdCij + dhSGhdC
c>noheats>       endif
           hS = h0SBA 
         return
         end

c########1#########2#########3#########4#########5#########6#########7##
c Fs-Px, not shifted by h0Astd, see coeffs.f
 
        FUNCTION hhSintg( x11, x22, Tij )
c_____________________________________________________________ lines  28
c 7-1-93  noheats version
c 6-24-93      newer yet cohSGh's from Gary of 6-24-93
c 6-12-93      new fit from Gary of 3-22-93 (ATAN instead of sqrt)
c 2-26-93  new formula for integral(hS(C,T)dC
computes.......hhSintg(x1,x2,T) = integral(hS(C,T)dC)(C1 to C2)....
called by: COEFFS.f, PHASE() 
calls    : cpSintg, TSofx  
calls    : external functions cpSintg, TSofx
c inputs:  x1, x2, Tij 
c outputs: hhSintg (J/g)
                     implicit double precision (a-h,o-z)
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/constant/ DhfusA, DhfusB, h0SA, h0SB, eS0TE, eS1TE
      dimension cohSGh(5)
c>> newest coefficients from Gary, 3-22-93
c 'H,FsPx,gh (kJ/kg)' = co1 * ( 1 + co2 * ATAN('X,Px,sol'-0.5)
c              + co3*('X,Px,sol'-0.5) + co4*ln(1+co5*('X,Px,sol'-0.5)) )
c3-12-93   DATA cohSGh / -14179.d0, -.8091, .8288, -.0066, 1.d6 /
           DATA cohSGh / -13633.d0, -.1021, .1721, -.0097, 1.d3 /

       EXTERNAL cpSintg, TSofx
c------
             CC( xij ) = WB * xij / ( WA + Wdiff * xij )
cc      .............formula for hS_Ghiorso(C):
c>noheats>      hSGh( CmC0 ) =   cohSGh(1)*( 1. + cohSGh(2)*ATAN( CmC0 )
c>noheats>     &  + cohSGh(3)*CmC0 + cohSGh(4)*LOG( 1.+cohSGh(5)*CmC0 ))

c>noheats>             C00 = .5d0
c>noheats>             C1  = CC( x11 )
c>noheats>             C2  = CC( x22 )
c>noheats>              x0 = 0.d0
c>noheats>              x1 = 1.d0
c>noheats>         h0SAofT = h0SA + cpSintg( x0, TA, Tij )
c>noheats>         h0SBofT = h0SB + cpSintg( x1, TB, Tij )

c>noheats>         h0SC1T = (1.-C1) * h0SAofT + C1 * h0SBofT
c>noheats>           C1mC0 = C1 - C00
c>noheats>       if( C1mC0 .LE. 0.0 ) then
c>noheats>                             DhSexC1 = 0.0
c>noheats>       else
c>noheats>            hSGhC1 = hSGh( C1mC0 )
c>noheats>              TSC1 = TSofx( x11 )
c>noheats>          h0SAofTS = h0SA + cpSintg( x0, TA, TSC1 )
c>noheats>          h0SBofTS = h0SB + cpSintg( x1, TB, TSC1 )
c>noheats>          h0SC1TS1 = (1.-C1) * h0SAofTS + C1 * h0SBofTS
c>noheats>          DhSexC1  =  hSGhC1 - h0SC1TS1
c>noheats>       endif
c>noheats>              tothSC1T = h0SC1T + DhSexC1

c>noheats>         h0SC2T = (1.-C2) * h0SAofT + C2 * h0SBofT
c>noheats>           C2mC0 = C2 - C00
c>noheats>       if( C2mC0 .LE. 0.0 ) then
c>noheats>                             DhSexC2 = 0.0
c>noheats>       else
c>noheats>            hSGhC2 = hSGh( C2mC0 )
c>noheats>              TSC2 = TSofx( x22 )
c>noheats>          h0SAofTS = h0SA + cpSintg( x0, TA, TSC2 )
c>noheats>          h0SBofTS = h0SB + cpSintg( x1, TB, TSC2 )
c>noheats>          h0SC2TS2 = (1.-C2) * h0SAofTS + C2 * h0SBofTS
c>noheats>          DhSexC2  =  hSGhC2 - h0SC2TS2
c>noheats>       endif
c>noheats>              tothSC2T = h0SC2T + DhSexC2

c>noheats>       hhSintg = tothSC2T - tothSC1T
          hhSintg = 0.
       return
       end 
