c file setup.f contains:  coeffs.f start.f mesh.f index2D.f frzspeed.f

 
c old file  other.f  contained:   coeffs.f  index2D.f  frzspeed.f

c########1#########2#########3#########4#########5#########6#########7##
c Fs-Px
        Subroutine COEFFs
cc____________________________________________________________ lines 90
c 6-24-93  new h0Astd, h0Bstd
c 2-20-93           modified for new FsPx properties, no cohL,cohhLig
c10-20-92           corrected cohL(1), moved DhfusA,DhfusB to common  
c 9-8-92            added eS1TE for hypereutectic case
c 7-4-92  COEFFs.f  finds coefficients for hL,hhLintg
c                         and the constants: h0SA,h0SB,eS0TE,DhfusE
              implicit double precision (a-h,o-z)

       EXTERNAL xLofT, cpSintg, cpLintg, hhSintg

      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
      common/ coefs / coCpS(7), coCpL(3), cohL(6), cohhLig(6)
      common/constant/ DhfusA, DhfusB, h0SA, h0SB, eS0TE, eS1TE
c2-20-93  DATA h0Astd / -15211.d0 /, h0Bstd / -14799.d0 /
          DATA h0Astd / -14280.d0 /, h0Bstd / -14638.d0 /

cc----for EUTECTIC only: find xE from TE (set in DATA in main)--------
c           xE = xLofT( TE )
c            write(6,*)'COEFFs: eutectic: xE, TE :',xE, TE
cc----for NON-eutectic, choose xE as the reference xB:
c            xE = 0.0
cc-------------------------
#if defined(PROFOMETER)
      call mark_profometer('YELLOW\0')
#elif defined(PERFOMETER)
      call mark_perfometer(YELLOW,"setup.F")
#endif
            T0ref =  25.d0
               x0 = 0.d0
               x1 = 1.d0
cc---------find value of the constant h0SA = h0Astd+cpSintg(0,T0ref,TA)
       h0SA =  h0Astd + cpSintg( x0, T0ref, TA)

cc---------find value of the constant h0SB = h0Bstd+cpSintg(1,T0ref,TB)
       h0SB =  h0Bstd + cpSintg( x1, T0ref, TB)

cc----------------find the coeffs for hL(x,T):
cc----------------find the coeffs for hhLintg(x1,x2,T)
c>>>> for the new FsPx, no coeffs needed, all done in hL.f, hhLintg.f

cc-------find value of the constant DhfusE = Dhfus(xE,TE):
         DhfAE = WA * ( DhfusA - cpLintg( x0, TE, TA )
     &                               + cpSintg( x0, TE, TA ) )
         DhfBE = WB * ( DhfusB - cpLintg( x1, TE, TB )
     &                               + cpSintg( x1, TE, TB ) )
             WxE = WA + Wdiff * xE
         DhfusE  =  ( (1.-xE) * DhfAE + xE * DhfBE  ) / WxE
c fus0:   DhfusE = 0.0  now can be set from dat via flag lfus0 in MAIN

cc---for EUTECTIC only: 
cc-------find value of the constant eS0TE = eS(0,TE)=hhSintg(xE,0.,TE)
cc-------           needed in eSLDS(), eM() for hypo-eutectic
c             eS0TE = h0SA + hhSintg( xE, x0, TE )
              eS0TE = 0.0
cc-------find value of the constant eS1TE = eS(1,TE)=hhSintg(xE,1.,TE)
cc-------           needed in eSLDS(), eM() for hyper-eutectic
c             eS1TE = h0SB + hhSintg( xE, x1, TE )
              eS1TE = 0.0

         write(6,*)'# COEFFs: xE,TE, DhfusE:',xE,TE, DhfusE
         write(6,*)'# COEFFs: h0SA, h0SB  :', h0SA, h0SB
c         write(6,*)'# COEFFs: eS0TE, eS1TE  :', eS0TE, eS1TE
         write(6,*)
      return
      end



c#####.##1#########2#########3#########4#########5#########6#########7##
c with void 
c for Fs-Px 
c non-uniform Twall with variable akW(T) = akW0 + akW1 [T - Tbry]

      Subroutine START( akWmax, V, Ip,Iw,Jp,Jw,Jv, Rin,Rout,
     &              C,CL,CS,x,e,T,alam,iphase, RS,RSold, Etotal,Ctotal )
c______________________________________________________________lines 283
c10-27-92                    corrected formulae for variable akW
c 8-16-92 non-uniform Twall: parabola from Tinit to Tbry in soil
c                           for variable akW(T) = akW0 + akW1 [T - Tbry]
c 7-17-92 non-uniform Twall: straight line from Tw1 to Tbry in soil
c 6-28-92 modified for Diopside - Anorthite, for ISV
c11-18-90 added r-location of Solidus(RS), for velocity output
c11- 4-90  changed void to have uniform Tvoid (rhoV=0),non-conducting
c10- 4-90    added void (free) space, j=0,-1,...,-Jv+1, conducting 
c12-20-89     Sets initial conditions and totals initial energies 
c              (Etotal) to be used for Energy balance in OUTPUT()
Calls EXTERNAL FUNCTIONs  TLofx(), eLQDS(), cpLintg()
c inputs : xinit,Tinit,Tbry,Ttop,Tvoid,Tw1  from INPUT()
c          rho,rhoV,,cpV, V(i,j)     from MAIN() and from MESH()
c outputs: C,CL,CS,x,e,T,alam,iphase,RS,RSold, Etotal,Ctotal
c---------------------------------------------------------------------
      implicit double precision (a-h,o-z)

        EXTERNAL TLofx, eLQDS, cpLintg

      DIMENSION C(Ip,Jp), x(Ip,Jp), iphase(Ip+1,Jp), RS(Jp),RSold(Jp) 
      DIMENSION CL(Ip,Jp), CS(Ip,Jp), alam(Ip,Jp) 
      DIMENSION e(Ip+Iw,1-Jw-Jv:Jp+Jw)
      DIMENSION T(Ip+Iw+1,1-Jw-Jv:Jp+Jw+1) 
      DIMENSION V(Ip+Iw,1-Jw-Jv:Jp+Jw) 

      common/  init / Tinit, Tbry, Ttop, Tvoid, Tw1
      common/weights/ WA,WB,Wdiff, TA,TB, xE,TE,Tref,DhfusE,xinit
      common/propts1/rho,cokL(3),cokS(2),rhoW,cpW,akW0,akW1,akV
      common/propts2/ DL,DS,delta,beta

cc------------------ formula for variable akW ------------------

             akW( Tij ) = akW0  + akW1 * ( Tij - Tbry )

       Etotal= 0.d0
cc******************* set T, e for soil(=wall) nodes *******************

cc_________________________uniform T = Tinit____________________________ 
c             einit = cpW * (Tinit - Tref)
c             rhoWein = rhoW * einit
c      DO 100  j = 1, Jw
c            DO 150  i = 1, Ip+Iw
c                    T(i,j-Jw-Jv)  = Tinit
c                    e(i,j-Jw-Jv) = einit
c	            Etotal = Etotal + rhoWein * V(i,j-Jw-Jv)
c                    T(i, Jp+j) = Tinit
c                    e(i, Jp+j) = einit
c                    Etotal = Etotal + rhoWein * V(i,Jp+j)
c  150       CONTINUE
c100   CONTINUE
c      DO 200  j = 1-Jv, Jp
c            DO 250  i = Ip+1, Ip+Iw
c                    T(i,j) = Tinit
c                    e(i,j) = einit
c	             Etotal = Etotal + rhoWein * V(i,j)
c  250       CONTINUE
c200   CONTINUE

cc.................top wall, all across: T = Ttop, e = etop.............

             etop  = cpW * ( Ttop - Tref )
             rhoWetop = rhoW * etop

#if defined(PROFOMETER)
      call mark_profometer('YELLOW\0')
#elif defined(PERFOMETER)
      call mark_perfometer(YELLOW,"setup.F")
#endif
      DO 100  j = 1, Jw
            DO 120  i = 1, Ip+Iw
                    T(i,j-Jw-Jv)  = Ttop
                    e(i,j-Jw-Jv) = etop
	            Etotal = Etotal + rhoWetop * V(i,j-Jw-Jv)
  120       CONTINUE
100   CONTINUE

cc_____non-uniform Twall: two options: akW=const OR =akW0+akW1[T-Tbry]
cc_____ akW=const.: in dat file: set akW1=0 and Tw1 =/= Tinit
cc      straight line  from specified  Tw1 at Ip+1 down to Tbry at Rout
cc_____for akW = akW0+akW1[T-Tbry]: parabola, set Tw1=Tinit in dat file

cd       if( Tw1  .EQ. Tinit ) goto 300
         if( akW1 .NE. 0.0   ) goto 300

cc________________non-uniform Twall: straight line, akW = const  _______

       akWmax = akW0

cc............bottom wall, slanted down corner: straight line profile:
cc                         from Tw1 at Jp+1 down to Tbry at Zin+Zw:
cc     T(z) = Tw1 - ( Tw1-Tbry)*( z - z(Jp+1) ) / ( Zin+Zw - z(Jp+1) )
cc ==> T(Jp+1) =  Tw1 - (Tw1-Tbry) * (j-1) / ( Jw - .5 )

      DO 210  j = 1, Jw
            DO 220  i = 1, Ip + j
                       Tbottom = Tw1 - (Tw1-Tbry)*(j-1)/(Jw-.5)
                    T(i, Jp+j) = Tbottom
                       ebottom = cpW * ( Tbottom - Tref )
                    e(i, Jp+j) = ebottom
                    Etotal = Etotal + rhoW * ebottom * V(i,Jp+j)
  220       CONTINUE
210   CONTINUE
cc............lateral wall,slanted down corner: straight line profile:
cc                         from Tw1 at Ip+1 down to Tbry at Rout:
cc     T(r) = Tw1 - (Tw1-Tbry)*( r - r(Ip+1) ) / ( Rout - r(Ip+1) ),
cc ==> T(Ip+i) = Tw1 - (Tw1-Tbry) * ( i-1 ) / ( Iw-.5 ), i=1,Iw

      DO 230  i = 1, Iw
            DO 240  j = 1, Jp + i-1
                        Tside = Tw1 - (Tw1-Tbry)*(i-1)/(Iw-.5)
                    T(Ip+i,j) = Tside
                        eside = cpW * ( Tside - Tref )
                    e(Ip+i,j) = eside
	             Etotal = Etotal + rhoW * eside * V(Ip+i,j)
  240       CONTINUE
230   CONTINUE
cc............lateral wall,next to void: straight line profile:
      DO 250  j = 1-Jv, 0
            DO 260  i = 1, Iw 
                        Tside = Tvoid - (Tvoid-Tbry)*(i-1)/(Iw-.5)
                    T(Ip+i,j) = Tside
                        eside = cpW * ( Tside - Tref )
                    e(Ip+i,j) = eside
                     Etotal = Etotal + rhoW * eside * V(Ip+i,j)
  260       CONTINUE
250   CONTINUE

              goto 390

300   continue
cc_______________non-uniform Twall: parabolic, variable akW ____________
cc                                  trigered by akW1=/=0  (Tw1 = Tinit)

       akWmax = 0.0
        DTin  = Tw1 - Tbry
        akW01 = akW0 / akW1

cc............bottom wall, slanted down corner: parabolic profile:
cc from specified  Tw1=Tinit at Zin down to Tbry at Zin+Zw:
cc parabolic steady-state distribution is root of the quadratic:
cc  [T(z)-Tbry]^2 + 2*akW01*[T(z)-Tbry] - DTin*( DTin + 2*akW01 ) *
cc                                            * (1 - (z-Zin)/Zw ) = 0
cc                         with  akW01=akW0/akW1,  DTin = Tw1 - Tbry.

      DO 310  j = 1, Jw
        DO 320  i = 1, Ip + j
                 CC = DTin*( DTin + 2 * akW01 ) * (1.0 - (j-.5)/Jw )
                  Q = akW01 + SIGN(1.d0,akW01)* SQRT( akW01*akW01 + CC )
cd            root1 = Tbry + CC / Q       root2 = Tbry - Q
            Tbottom = Tbry + CC / Q
                        akWij = akW( Tbottom )
                       akWmax = MAX( akWij, akWmax )
          T(i, Jp+j) = Tbottom
             ebottom = cpW * ( Tbottom - Tref )
          e(i, Jp+j) = ebottom
              Etotal = Etotal + rhoW * ebottom * V(i,Jp+j)
  320   CONTINUE
310   CONTINUE

cc............lateral wall,slanted down corner: parabolic profile:
cc from specified  Tw1=Tinit at Rin down to Tbry at Rout:
cc parabolic steady-state distribution is root of the quadratic:  
cc  [T(r)-Tbry]^2 + 2*akW01*[T(r)-Tbry] -  DTin*(DTin+2*akW01) *
cc                                    * LOG(r/Rout) / LOG(Rin/Rout) = 0
cc                         with  akW01=akW0/akW1,  DTin = Tw1 - Tbry.
         RoR = Rin / Rout 
       RoRm1 = 1.0 - RoR
       rLOGR = LOG( RoR )

      DO 330  i = 1, Iw
        DO 340  j = 1, Jp + i-1
               rioR = RoR + RoRm1 * ( i-.5 ) / Iw 
               rLOG = LOG( rioR ) / rLOGR 
                 CC = DTin * ( DTin + 2 * akW01 ) * rLOG
                  Q = akW01 + SIGN(1.d0,akW01)* SQRT( akW01*akW01 + CC )
cd            root1 = Tbry + CC / Q       root2 = Tbry - Q
              Tside = Tbry + CC / Q
                        akWij = akW( Tside )
                       akWmax = MAX( akWij, akWmax )
            T(Ip+i,j) = Tside
                eside = cpW * ( Tside - Tref )
            e(Ip+i,j) = eside
               Etotal = Etotal + rhoW * eside * V(Ip+i,j)
  340   CONTINUE
330   CONTINUE

cc............lateral wall,next to void: parabolic profile:
       DTvoid = Tvoid - Tbry

      DO 350  j = 1-Jv, 0
        DO 360  i = 1, Iw 
             rioR = RoR + RoRm1 * ( i-.5 ) / Iw 
             rLOG = LOG( rioR ) / rLOGR
               CC = DTvoid * ( DTvoid + 2 * akW01 ) * rLOG
                Q = akW01 + SIGN(1.d0,akW01)* SQRT( akW01*akW01 + CC )
cd                 root1 = Tbry - Q        root2 = Tbry + CC / Q
              Tside = Tbry + CC / Q
                        akWij = akW( Tside )
                       akWmax = MAX( akWij, akWmax )
            T(Ip+i,j) = Tside
                eside = cpW * ( Tside - Tref )
            e(Ip+i,j) = eside
               Etotal = Etotal + rhoW * eside * V(Ip+i,j)
  360   CONTINUE
350   CONTINUE

cc-----------------printout
390     write(6,*)'START: check initial T by void & in corner'
        write(6,*)'next to void: T(i,0): '
        write(6,393)     ( T(i,0), i = Ip+1, Ip+Iw )
        write(6,*)'bottom right corner: T(i,1): '
        do 392 j = Jp+1, Jp+Jw
                   write(6,393) ( T(i,j), i = Ip+1, Ip+Iw )
 392    continue
  393   format(2x, 10f7.0 ) 

cc********************** set T, e for void nodes **********************
cd conducting void:       einitV = cpV * (Tinit - Tref)
cd                        rhoVein = rhoV * einitv
cc non-conducting: rhoV=0 => e=0,T=Tvoid (uniform temperature in void):
            einitV = 0.d0
      DO 400  j = 1-Jv, 0
            DO 450  i = 1, Ip
                    T(i,j) = Tvoid
                    e(i,j) = einitV
cc conducting void:                 Etotal = Etotal + rhoVein * V(i,j)
  450       CONTINUE
400   CONTINUE

cc************  IF starting all SOLID at Tinit <= TE,  then :**********
cc-----   find eSinit = eSOL(xinit,Tinit) 
cc  ? old             = eS(x,TE) + cpSintg(xinit,Tinit,W(xinit))
cc. ?     ...EXTERNAL.. cpSintg(xinit,Tinit,W(xinit))=sensible heat
c   ?        cpSintgr = cpSintg( xinit, Tinit ) 
c   ?          eSinit = -6232.7 * xinit + cpSintgr

cc************ starting all liquid at Tinit >= TL(xinit) , so:**********
cc-----   find eLinit = eL(xinit,Tinit) 

cd Method 1: up to (xE,Tin),left to (xin,Tin):
cd               eLinit = DhfusE+cpLintg(xE,TE,Tin)+hhLintg(xE,xin,Tin)
cd    where:           sensible heat = cpLintg(xE,TE,Tinit),....EXTERNAL
cd                          cpLintgr = cpLintg( xE, TE, Tinit )
cd               heat of mixing = hhLintg(xin,Tin)-(xE,Tin),....EXTERNAL
cd                     hhLintgr = hhLintg( xE, xinit, Tinit )
cd               liquid energy eL(xinit, Tinit )
cd                             eLinit = DhfusE + cpLintgr + hhLintgr

cc Method 2: up to (xE,TL(x)), left to LIQUIDUS,up to (xin,Tin):
cc                  eLinit = eLQDS( xin ) + cpLintg( xin, TL(xin), Tin )
cc                           calling externals TLofx, eLQDS, cpLintg
              TLxin = TLofx( xinit )
           eLinit = eLQDS( xinit ) + cpLintg( xinit, TLxin, Tinit )

c+++++++++++++++++++++ set all initial values inside +++++++++++++++++++
              rhoeLin= rho * eLinit
              Ctotal = 0.d0

                Wxin = WA + Wdiff * xinit
               Cinit = WB * xinit / Wxin 

      DO 500  j= 1,Jp
          DO 550  i = 1, Ip
                  alam(i,j) = 1
                  T(i,j) = Tinit
                  C(i,j) = Cinit
                           Ctotal = Ctotal + Cinit * rho * V(i,j)
cc...     ..................for starting ALL LIQUID:
                  CL(i,j) = Cinit
                  CS(i,j) = 0.d0
                  x(i,j) = xinit
                  e(i,j) = eLinit
                  iphase(i,j) = 3
                  Etotal = Etotal + rhoeLin * V(i,j)
  550     CONTINUE
c.    ............initialize r-location of Solidus = Rin............
cv              RSold(j) = Rin
cv              RS(j)    = Rin
500   CONTINUE
cd                     write(Iout,*)'-----in START: Etotal=',Etotal
              return
               end



c#####.##1#########2#########3#########4#########5#########6#########7##
c with void
      SUBROUTINE MESH( Ip,Iw,Jp,Jw,Jv,
     &                  Dr,DrW,Dz,DzW,DzV, r,r2,z,z2, Ar,Az,V, sratioW, 
     &                             ArIp,AzJv, drokIp,dzokJv, zkv0,zz21 )
c______________________________________________________________lines 146
c 8-17-92  variable akW(T)= akW0 + akW1*[T-Tbry]
c10-4-90    added void (free) space, j=0,-1,...,-Jv+1
c 6-26-89                    sets up mesh, areas, volumes 
c--------
c inputs: Rin,Rout,Zin,Zw,Zv, Ip,Iw, Jp,Jw,Jv  
c         rhoW,cpW,akW0,akW1,akV  via common/propts/ 
c outputs: Dr,DrW,Dz,DzW,DzV 
c          r(i),r2(i),z(j),z2(j), Ar(i,j),Az(i,j),V(i,j)
c          drokIp,dzokJv,ArIp,AzJv  needed in PHASE()
c          sratioW                  needed in PROFLUX()

      implicit double precision (a-h,o-z)

      parameter (Pi=3.141592653589793d0)
c tighter
      DIMENSION   r(Ip+Iw),    z(1-Jw-Jv:Jp+Jw)
      DIMENSION  r2(Ip+Iw+1), z2(1-Jw-Jv:Jp+Jw+1)
      DIMENSION  Ar(Ip+Iw+1,1-Jw-Jv:Jp+Jw)
      DIMENSION  Az(Ip+Iw,1-Jw-Jv:Jp+Jw+1) 
      DIMENSION   V(Ip+Iw,1-Jw-Jv:Jp+Jw)

      common/ size  / Rin, Rout, Zin, Zw, Zv
      common/propts1/rho,cokL(3),cokS(2),rhoW,cpW,akW0,akW1,akV
      common/propts2/ DL,DS,delta,beta

cc--------define radial nodes and faces(midway btwn nodes) in the wall:
#if defined(PROFOMETER)
      call mark_profometer('YELLOW\0')
#elif defined(PERFOMETER)
      call mark_perfometer(YELLOW,"setup.F")
#endif
         DrW = (Rout-Rin)/Iw
         r2(Ip+1) = Rin
         r(Ip+1) = Rin + DrW/2
      do 100  i = 2, Iw
            r(Ip+i) = r(Ip+i-1) + DrW
            r2(Ip+i) = (r(Ip+i-1) + r(Ip+i)) / 2
100   continue
         r2(Ip+Iw+1) = Rout
cc.................. define radial nodes and faces (midway) in PCM:
c        Dr = (Rin-.5d0*DrW)/(Ip-.5d0)
cc...   ..............or, equally spaced radial nodes:
	 Dr = Rin / Ip 
         r(1) = Dr / 2
         r2(1) = 0.d0
      do 200  i = 2, Ip
            r(i) = r(i-1) + Dr
            r2(i) = (r(i-1) + r(i)) / 2
200   continue
cc..................define z -nodes and faces in top & bottom walls:
         DzW = Zw/Jw
         z2(-Jw-Jv+1) = -Zw-Zv
         z(-Jw-Jv+1) = -Zw-Zv + DzW/2
         z2(Jp+1) = Zin
         z(Jp+1) = Zin + DzW/2
      do 300 j = 2,Jw
            z(-Jw-Jv+j) = z(-Jw-Jv+j-1) + DzW
            z2(-Jw-Jv+j) = (z(-Jw-Jv+j-1) + z(-Jw-Jv+j)) / 2
            z(Jp+j) = z(Jp+j-1) + DzW
            z2(Jp+j) = (z(Jp+j-1) + z(Jp+j)) / 2
300   continue
         z2(Jp+Jw+1) = Zin + Zw
cc..................define z -nodes and faces (midway) in PCM:
c        Dz = (Zin-DzW) / (Jp-1)
c        z(1) = .5d0*DzW
cc...   ..........or, equally spaced axial nodes:
	 Dz = Zin / Jp 
         z(1) = Dz / 2
         z2(1) = 0.d0
      do 400 j = 2,Jp
            z(j) = z(j-1) + Dz
            z2(j) = (z(j-1) + z(j)) / 2
400   continue
cc------------------ define z -nodes (equispaced) and faces in void:
       if( Jv .EQ. 0 ) then
                           DzV = Zv
       else
                           DzV = Zv/Jv
       endif
         z2(1-Jv) = -Zv
         z(1-Jv) = -Zv + DzV/2
      do 450 j = 2,Jv
            z(j-Jv) = z(j-Jv-1) + DzV
            z2(j-Jv) = (z(j-Jv-1) + z(j-Jv)) / 2
450   continue
c................... quantities needed in PHASE() for Tvoid :
c ?? no longer used ??
         drokIp = (r(Ip+1)-r2(Ip+1))/akW0 + (r2(Ip+1)-r(Ip))/akV
         dzokJv = (z(1-Jv)-z2(1-Jv))/akV + (z2(1-Jv)-z(-Jv))/akW0
           ArIp = 2*Pi*Rin*Zv
           AzJv = Pi*(Rin**2)
           zz21 =  z(1) - z2(1)
           zkv0 = (z2(1) - z(0)) / akV  

c       write(6,*)'MESH: nodes and faces:'
c       write(6,491) ( r(i), i=1,Ip+Iw )
c       write(6,492) ( r2(i), i=1,Ip+Iw+1 )
c       write(6,493) ( z(j), j=-Jv-Jw+1,Jp+Jw )
c       write(6,494) ( z2(j), j=-Jv-Jw+1,Jp+Jw+1 )
 491   format('r(i) : ',16f6.2 )
 492   format('r2(i): ',17f6.2 )
 493   format('z(i) : ',10f6.2 )
 494   format('z2(i): ',11f6.2 )
cc------------------compute volumes and facial areas-------------------- 
cc........also find max radial and axial areas for determining dt
cd        AroVmax = 0
cd        AzoVmax = 0
cd        Artot   = 0
cd        Vsum    = 0
      do 500  j = -Jw-Jv+1, Jp+Jw
            Dz2j = z2(j+1) - z2(j)
         do 550  i = 1, Ip+Iw
               Ar(i,j) = 2*Pi * r2(i)*Dz2j
               Az(i,j) = Pi * ( r2(i+1)**2 - r2(i)**2 ) 
               V(i,j) = Az(i,j) * Dz2j
cd               Vsum = Vsum + V(i,j)
cd               AroVmax = max(AroVmax,Ar(i,j)/V(i,j))
  550    continue
cd               AzoVmax = max( AzoVmax, 1/Dz2j )
            Ar(Ip+Iw+1,j) = 2*Pi* Rout * Dz2j
c	         Artot = Artot + Ar(Ip+Iw+1,j)
cd               AroVmax = max(AroVmax,Ar(Ip+Iw+1,j)/V(Ip+Iw,j))
500   continue
c                Aztot = 0
      do 700  i = 1,Ip+Iw
            Az(i,Jp+Jw+1) = Pi* (r2(i+1)**2 - r2(i)**2)
c            Aztot = Aztot + Az(i,Jp+Jw+1) 
700   continue
c            Aztot = 2 * Aztot
c**
c..determine the smallest sratioW for the wall, needed in PROFLUX():
         Drmin = min( Dr,DrW )
         Dzmin = min( Dz,DzW )
         ratio = 1/(Drmin*Drmin) + 1/(Dzmin*Dzmin)
         ratiobry = 1/(DrW*DrW) + 3/(DzW*DzW)
         ratioW = 2.d0 - DrW/Rout
         ratioW = (1+1/ratioW)/(DrW*DrW) + 1/(DzW*DzW)
         ratioMAX = MAX( ratio, ratioW, ratiobry )
cd          sratioW = rhoW*cpW / (2* ratioMAX * akW)
cc akW(T): leave out /akW to be done in PROFLUX :
          sratioW = rhoW*cpW / (2* ratioMAX )
c>>for CONDUCTING void, do in main.f:  
c                         ratioV  = 1/(Drmin*Drmin) + 1/(DzV*DzV)
c                         sratioV = rhoV*cpV / (2* ratioV * akV)

c...compare this with the srat below (do in PROFLUX,not here):
cd       ratmax = AroVmax/Drmin + AzoVmax/Dzmin
cd       rhocpmin = MIN(rho*cp,  rhoW*cpW)
cd       akmax = max(ak,akW)
cd       srat =  rhocpmin / (akmax * ratmax)

c      write(6,*)'>>>> leaving MESH, '
                 return
                  end



c#######################################################################

      subroutine INDEX2D( Rin, Zv,Zw, r2,z2, Ip,Jp,Iw,Jw,Jv,   idr,idz )
cd     &           NOcyl ,easting,orthing,elevation,East0,Orth0,Elev0 ) 
c_____________________________________________________________ lines 145
c11-4-92         rescale rth(no) = rth(no)* Rin / 1.5 => Rin <-> 1.5m
c11-1-92         shifted z w.r.t. melt surface: zth(no)=zth(no)-Zv-Zw 
c7-28-92 shift down .3 m Gary's request for #76,77,78,79 
c                   zth(no) = zth(no) + .3 
c7-20-92  modified index.f from .../heat/, for 2D case
c1- 8-92  find NOcyl(i,j,k)= index of thermocouple contained in V(i,j,k)
called by main.f
c needs r2,z2   generated by MESH(), passwd thru arguments
c reads ../locations/locations.isv to get easting,orthing,elevation
c finds idr(no),idth(no),idz(no), NOcyl(i,j,k)
c---------------------additional variables------------------------------
c xth(no),yth(no),zth(no) = local (x,y,z) coord of thermocpl number no
c                           obtained from the actual ORNL-grid location
c rth(no),thth(no),zth(no)= (r,th,z) coord of thermocouple number no
c                           obtained from the actual ORNL-grid location

                        implicit real*8(a-h,o-z)
      parameter (nobs=87)
      character*11 therm(nobs)
      integer idr(nobs),idth(nobs),idz(nobs)
c      integer NOcyl(0:nodesr,0:nodesth,1:nodesz) 
      DIMENSION  r2(Ip+Iw+1), z2(1-Jw-Jv:Jp+Jw+1)
      DIMENSION   xth(nobs), yth(nobs), zth(nobs)
      DIMENSION   rth(nobs), thth(nobs)
      DIMENSION  easting(nobs), orthing(nobs), elevation(nobs)

#if defined(PROFOMETER)
      call mark_profometer('YELLOW\0')
#elif defined(PERFOMETER)
      call mark_perfometer(YELLOW,"setup.F")
#endif
                 PI = 4.0 * ATAN(1.d0)

cc  ORNL coordinates of the origin (in feet):
        East0 = 24848.818d0
        Orth0 = 17443.169d0
        Elev0 = 838.5d0
cc  need angle of rotation between Easting and 0 degrees (x-axis),
              angle = PI / 4
calculate cos(angle), sin(angle) for rotation of coordinates:
        COSangle = COS( angle ) 
        SINangle = SIN( angle )

cc---------read thermocouple names from file 'locations.isv'--------
cc              and actual locations (ORNL coordinates, in feet)
      open (unit=13,file=
c     &      '/home/sun4/u5/vasili/ISV/Data/locations/locations.isv'
     &      '../locations.isv'
     &                                                   ,status='old')
      do l=1,31
        read(13,*)
      enddo
      do 20 no=1,nobs
         read(13,21)therm(no),easting(no),orthing(no),elevation(no)
 21      format(a11,1x,f9.3,1x,f9.3,1x,f7.3)
cc..     ......................shift to trench center as origin:
                       east1 =  easting(no) - East0
                       orth1 =  orthing(no) - Orth0
cc..     ......................rotate to local x-y-z system, in meters:
                xth(no) = ( east1 * COSangle + orth1 * SINangle )*.3048
                yth(no) = (- east1 * SINangle + orth1 * COSangle)*.3048
                zth(no) = ( Elev0 - elevation(no) )*.3048

cc..     ....................find the CYL coordinates (meters,radians):
cc..     ........................ w.r.t. trench center, ground level:
                rth(no) = SQRT( xth(no)**2 + yth(no)**2 )
c                 theta  = ATAN( yth(no) / xth(no) )
c                 if( xth(no) .LT. 0.0 ) then
c                                            thth(no) = theta + PI
c                 elseif( yth(no) .LT. 0.0 ) then
c                                            thth(no) = theta + 2*PI
c                 else
c                                            thth(no) = theta
c                 endif 
c               if( thth(no) .GT. th2(6) ) thth(no) = thth(no) - 2*PI

c7-28-92 temporary shift down .3 m per Gary's request for #76,77,78,79
                   zth(no) = zth(no) + .3
cd                 write(7,*)'INDEX2D: shifted: zth(no) = zth(no) + .3'
c11-1-92 ....... shift z to melt surface:
                 zth(no) = zth(no) - Zv - Zw

20    continue
              close(13)

cc-------------for each thermocouple find idr=i, idth=j, idz=k ---------
cc  with (i,j,k) the CYLINDRICAL control volume containing the thermocpl

c      write(3,*)'==> thermocpl.in-grid <== fort.3 output from index.f'
c      write(3,*)'                       with r2(i),th2(j),z2(k) :'
c      write(3,93) (r2(i)*100/2.54 , i=0, nodesr+1)
c      write(3,93) (th2(j)*180/PI  , j=0, nodesth+1)
c      write(3,93) (z2(k)*100/2.54 , k=0, nodesz+1)
c  93              format( 13f7.2 )
c      write(3,*)'   (idr idth idz) = index(i,j,k) of the CYL CV'
c      write(3,*)'                              containing the thmcpl'
c      write(3,*)'   (rth thth zth) = actual CYL. coord.  (m,rad,m)' 
c      write(3,*)'   (xth  yth zth) = actual local CART coord (m,rad,m)'
c      write(3,*)'              in (m,rad,m) and in (inches,deg,inches)'
c      write(3,*)'No.   Label   idr-th-z     rth   thth    zth',
c     &          '      xth     yth    zth'
c      write(3,*)'.....................................................'

       DO  100  no = 1, nobs

c11-4-92: rescale rth to Rin <--> 1.5 meters:
                   rth(no) = rth(no) * Rin / 1.5d0 

         DO 110  i = 1, Ip+Iw + 1
cc from actual position:
               if( rth(no) .LT. r2(i) ) then
                                        idr(no) = i-1
                                        goto 125
c               else
c                   goto 110
               endif
  110     CONTINUE
c skip: 115      DO 120  j = 1, nodesth + 1
cc from actual position:
c              if( thth(no) .LT. th2(j) ) then
c                                          idth(no) = j-1
c                                          goto 125
c             else
c                 goto 120
c             endif
c  120     CONTINUE
c 125      DO 130  k = 2, Jp+Jw + 1
 125      DO 130  k = 2-Jv-Jw , Jp+Jw + 1
cc from actual position:
              if( zth(no) .LT. z2(k) ) then
                                          idz(no) = k-1
                                          goto 135
c             else
c                 goto 130
             endif
  130     CONTINUE
 135    continue
cc.....  .........find NOcyl = thermocouple NO contained in V(i,j,k)
c                NOcyl( idr(no), idth(no), idz(no) ) = no

100     CONTINUE

cc..............set NOcyl(i,j,k) for those that contain more than one:
cc for grid.3 (see vol-thrmcpls.3): 
cc      0 2 5 contains no=5 & 75; 0 2 7 contains 7,8,80
cc set them to the TE-C thermocouples: 75 and 80:
c              NOcyl(0,2,5) = 75
c              NOcyl(0,2,7) = 80
cc for grid.4 (see vol-thrmcpls.4):
cc   0 2  5  contains  no= 4,74;  0 2  6  no=5,6,75;  0 2  7  no=7,8,80
c               NOcyl(0,2,5) = 74
c               NOcyl(0,2,6) = 75
c               NOcyl(0,2,7) = 80
cc---------------------------end of indexing----------------------------
        return 
        end




c########1#########2#########3#########4#########5#########6#########7##

      subroutine FRZSPEED( alam,alamold,iphase,RS,RSold,vel, iphase1 
     &               ,vt,velAVE,Tavst,Tstp,n,nm,vmax0,vmax1,vmax2,velMAX
     &                    ,time,dt,nsteps, Jzhis,  Ip,Iw, Jp,Jw,Jv )
c_____________________________________________________________ lines  82
c5-27-92 made into a separate subroutine
c7-  -91 by Peter Hoff, find freezing speed info
                implicit double precision (a-h,o-z)
      DIMENSION iphase(Ip+1,Jp),n(Jp),nm(Jp)
      DIMENSION RS(Jp),RSold(Jp),vel(Jp),alam(Ip,Jp),alamold(Ip,Jp) 
      DIMENSION vt(Jp),velAVE(Jp),Tavst(Jp),Tstp(Jp)

cp ---------------            Find rate of change for liquid fractions
#if defined(PROFOMETER)
      call mark_profometer('YELLOW\0')
#elif defined(PERFOMETER)
      call mark_perfometer(YELLOW,"setup.F")
#endif
      do 253 j = 1, Jp
         vel(j)=0.0
         do 252 i=1, Ip
            if (alam(i,j) .EQ. 0.0) goto 252
                vel(j)=(alamold(i,j)-alam(i,j))/dt
252      continue
       vt(j)=vt(j)+vel(j)
253   continue 
cc------------------------------- Find velMAX over z at this time
      velMAXz=0.0 
      iphase1 = 0
      do 300 j = 1,Jp
             iphase1 = MAX( iphase(1,j) , iphase1 )
c             vel(j) = (RSold(j)-RS(j))/dt
         if( vel(j) .GT. velMAXz) then 
                   velMAXz = vel(j)
                   jVELmax = j
         end if
300   continue
cp ...                      find time when freezing begins
      if (time .GT. 20.0) goto 305    
         do 304 j=1,Jp
           if( vel(j) .EQ. 0) then
              n(j)=nsteps+1
             Tavst(j) = time + dt
          end if
304    continue
305   continue
c...... ...............    find time when freezing ends
      if (time.LT.21.0) goto 307
         do 306 j=1,Jp
           if(vel(j).EQ.0) then
               nm(j)=nm(j)+1
               Tstp(j)=Tstp(j)+dt
           end if
306      continue
307   continue
cc..  ..............find velMAX over time
      if( velMAXz .GT. velMAX ) then
          velMAX   = velMAXz
          tVELmax  = time
          jVELmax2 = jVELmax
      end if
cp....            .....find vmax for top,middle,bottom
      if(vel(1) .GT. vmax0) then
        vmax0=vel(1)
        tvmax0=time
      end if
      if(vel(Jzhis) .GT. vmax1) then
        vmax1=vel(Jzhis)
        tvmax1=time
      end if
      if(vel(Jp) .GT. vmax2) then
        vmax2=vel(Jp)
        tvmax2=time
      end if
c---------------------find ave velocities,smallest
c      vAVmn=10.0
c      do 310 j=1,Jp
c             velAVE(j)=vt(j)/(nsteps-n(j)-nm(j))
c             if (velAVE(j).LT.vAVmn) then
c                vAVmn=velAVE(j)
c                jAVmn=j
c             end if
c310   continue
cc-------------
               return
               end

