#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <memory.h>

#ifndef _WIN32
  #include <unistd.h>
  #include <sys/time.h>
#endif

void do_2flops(int n)
{
  int i;
  double a = 0.5, b = 6.2, c = 0.0;

  for (i=0; i < n; i++) {
    c = a*b;
  }
}

void do_3flops(int n)
{
  int i;
  register float a = (float)0.5, b = (float)6.2, c, d;

  for (i=0; i < n; i++) {
    c = a+b;
    d = a*b;
    c += d;
  }
}

void do_4flops(int n)
{
  int i;
  register float a = (float)0.5, b = (float)6.2, c, d;

  for (i=0; i < n; i++) {
    c = a+b;
    d = a*b;
    c += d;
    d += d;
  }
}

int main(int argc, char **argv)
{
  int i = 1;

#ifdef PROFOMETER
  extern void profometer();
  profometer();
#elif defined(PERFOMETER)
  extern void perfometer();
  perfometer();
#endif

  while (i++)
    {
      if (i % 4)
	do_4flops(1000000);
      else if (i % 3)
	do_3flops(2000000);
      else
	do_2flops(4000000);
    }

  exit(0);
}
