cc file  solveT.f  contains:  TinMUSH.f  TinSOL.f  TinVOID.f

c########1#########2#########3#########4#########5#########6#########7##
c11- 9-92 for Fs-Px, set to eSxTSij, eLxTLij at TSij, TLij
c 6-17-92              modified for Diopside-Anorthite, for ISV
c 1-19-90    zeroin.f  modified to solve eM(xij,Tij) - eij = 0 for Tij 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC101
C      TITLE:  ZEROIN( AX,BX,F,TOL )  by Cody
C      A ZERO OF THE FUNCTION  F(X)  IS COMPUTED IN THE INTERVAL AX,BX .
C      THIS FUNCTION SUBPROGRAM IS A SLIGHTLY  MODIFIED  TRANSLATION  OF
C  THE ALGOL 60 PROCEDURE  ZERO  GIVEN IN  RICHARD BRENT, ALGORITHMS FOR
C  MINIMIZATION WITHOUT DERIVATIVES, PRENTICE - HALL, INC. (1973).
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

cd   DOUBLE PRECISION FUNCTION TinMUSH( AX,BX,TOL, eij, xij, NeMeval )

      FUNCTION TinMUSH( AX,BX,TOL, eij, xij, eSxTSij, eLxTLij, NeMeval )

                implicit double precision (a-h,o-z)
 
cv     DOUBLE PRECISION AX,BX,F,TOL
cv     DOUBLE PRECISION  A,B,C,D,E,EPS,FA,FB,FC,TOL1,XM,P,Q,R,S
cv     DOUBLE PRECISION  DABS,DSIGN
      EXTERNAL eM
C
C  COMPUTE EPS, THE RELATIVE MACHINE PRECISION c      EPS = D1MACH(4)
#if defined(PROFOMETER)
      call mark_profometer('magenta\0')
#elif defined(PERFOMETER)
      call mark_perfometer(MAGENTA,"solveT.F")
#endif
       EPS = 1.d-16
C
C INITIALIZATION
      A = AX
      B = BX
cv >>            changed from  FA = F(A) ,  FB = F(B)  to:
cv  old     FA = eM( xij, A, eij, NeMeval ) - eij
cv  old     FB = eM( xij, B, eij, NeMeval ) - eij
cv >> however, always A=TSij, B=TLij, and we should have:
cv >>         eM(xij,TSij) = eSLDS(xij), eM(xij,TLij) = eLQDS(xij), 
cv >> so just set them:
       FA = eSxTSij - eij
       FB = eLxTLij - eij
cv >>note: one more FB = eM(xij,B,N) - eij at the end of file
cv >>      and change the name zeroin to TinMUSH at last line
cv >>            added change-of-sign test:
      if ( FA*FB .GT. 0. ) then
        write(6,*)' F(A)*F(B) NOT negative in TinMUSH !, STOP'
        STOP
      endif
C
C BEGIN STEP
   20 C = A
      FC = FA
      D = B - A
      E = D
   30 IF (DABS(FC) .GE. DABS(FB)) GO TO 40
      A = B
      B = C
      C = A
      FA = FB
      FB = FC
      FC = FA
C CONVERGENCE TEST
   40 TOL1 = 2.0D0*EPS*DABS(B) + 0.5D0*TOL
      XM = .5*(C - B)
      IF (DABS(XM) .LE. TOL1) GO TO 90
      IF (FB .EQ. 0.0D0) GO TO 90
C IS BISECTION NECESSARY
      IF (DABS(E) .LT. TOL1) GO TO 70
      IF (DABS(FA) .LE. DABS(FB)) GO TO 70
C IS QUADRATIC INTERPOLATION POSSIBLE
      IF (A .NE. C) GO TO 50
C LINEAR INTERPOLATION
      S = FB/FA
      P = 2.0D0*XM*S
      Q = 1.0D0 - S
      GO TO 60
C INVERSE QUADRATIC INTERPOLATION
   50 Q = FA/FC
      R = FB/FC
      S = FB/FA
      P = S*(2.0D0*XM*Q*(Q - R) - (B - A)*(R - 1.0D0))
      Q = (Q - 1.0D0)*(R - 1.0D0)*(S - 1.0D0)
C ADJUST SIGNS
   60 IF (P .GT. 0.0D0) Q = -Q
      P = DABS(P)
C IS INTERPOLATION ACCEPTABLE
      IF ((2.0D0*P) .GE. (3.0D0*XM*Q - DABS(TOL1*Q))) GO TO 70
      IF (P .GE. DABS(0.5D0*E*Q)) GO TO 70
      E = D
      D = P/Q
      GO TO 80
C BISECTION
   70 D = XM
      E = D
C COMPLETE STEP
   80 A = B
      FA = FB
      IF (DABS(D) .GT. TOL1) B = B + D
      IF (DABS(D) .LE. TOL1) B = B + DSIGN(TOL1, XM)
cv >>>>>here:
              FB = eM( xij, B, NeMeval ) - eij

      IF ((FB*(FC/DABS(FC))) .GT. 0.0D0) GO TO 20
      GO TO 30
C DONE
cv >>>>>>>>>>>>>>> and here:
   90 TinMUSH = B
      RETURN
      END


c########1###########################################################7##
c Fs-Px 

      FUNCTION  TinSOL( Tguess, xij , TSij , emeSij, TOL, maxNEWT )
cc____________________________________________________________ lines  39
c 6-17-92
cc solves for T the equation F(T)= cpSintg(x,T)-emeSij =0 via NEWTON
called by:  PHASE() in solid case ( emeSij = eij - eSxTSij <= 0 )
calls    :  external functions TSofx,  cpSintg(), cpS()
c inputs:  starting Tij,  xij, emeSij, TOL, NO: maxNEWT
c output:  TinSOL = solution = new Tij 
cc-------
         implicit double precision (a-h,o-z)
         EXTERNAL cpSintg, cpS
      common/weights/WA,WB,Wdiff,TA,TB,xE,TE,Tref,DhfusE,xinit
cc-------
c         maxNEWT = 1000
#if defined(PROFOMETER)
      call mark_profometer('magenta\0')
#elif defined(PERFOMETER)
      call mark_perfometer(MAGENTA,"solveT.F")
#endif
         Newton = 0
         Tij    = Tguess
c passed as argument:   TSij  = TSofx( xij )
cc..................................find cpSintg(x,T) to form F(Tij)
  100    Newton = Newton + 1
                  cpSig = cpSintg( xij , TSij, Tij )
           FTij = cpSig - emeSij
cc        .........................find d F(T) / dT = cpS(x,T), EXTERNAL
          DFTij = cpS( xij, Tij )
         deltaT = FTij / DFTij
           Tij  =  Tij - deltaT
cc..............................test for convergence:
         if( Newton .GT. maxNEWT ) goto 950
         if( ABS( deltaT ) .GT. TOL ) goto 100
         if( ABS(  FTij  ) .GT. TOL ) goto 100
cc.......................................else we have converged, so
 900         TinSOL = Tij
       return

950        write(6,*)'TinSOL exceeded ',maxNEWT,' iterations, EXIT'
       stop
       end


c********************** update T(i,j) in the void **********************

        FUNCTION TinVOID( T,alam, Ip,Iw,Jp,Jw,Jv,Dr,
     &                         Ar,Az,ArIp,AzJv,drokIp,dzokJv,zkV0,zz21 )
c______________________________________________________________ lines 58
c 6-19-93 variable akS(T), akL(T) external
cc 7-6-92  made it into a subroutine, used to be at the end of PHASE()
                implicit double precision (a-h,o-z)
      DIMENSION alam(Ip,Jp)
      DIMENSION T(Ip+Iw+1,1-Jv-Jw:Jp+Jw+1)
      DIMENSION Ar(Ip+Iw+1,1-Jw-Jv:Jp+Jw)
      DIMENSION Az(Ip+Iw,1-Jw-Jv:Jp+Jw+1)

      common/propts1/rho,cokL(3),cokS(2),rhoW,cpW,akW0,akW1,akV
      common/switch /T32kL

      EXTERNAL  akL, akS

cc---- NON-conducting void: assuming rhoV~=0, and uniform Tvoid --------
cc---------- solve sum(fluxes around the void)=0 for Tvoid -------------

#if defined(PROFOMETER)
      call mark_profometer('magenta\0')
#elif defined(PERFOMETER)
      call mark_perfometer(MAGENTA,"solveT.F")
#endif
                           Jv1 = -Jv+1
                           Azi = 0.d0
                          AzTi = 0.d0
                         AzTJv = 0.d0
        DO 400 i = 1 , Ip
cc..      ..................now find  Reffi = Reff(i,1).................
            Ti1 = T(i,1)
          akLi1 = akL( Ti1 )
          akSi1 = akS( Ti1 )
          Reffi = alam(i,1) / akLi1 + ( 1.d0-alam(i,1) ) / akSi1
cc..     .................and the quantities needed for Tvoid...........
               rR = zz21 * Reffi + zkV0
cc..     ......where, from MESH:  zz21=z(1)-z2(1), zkV0=(z2(1)-z(0))/akV
                   Azi = Azi + Az(i,1)/rR
                  AzTi = AzTi + Az(i,1) * T(i,1) / rR
                 AzTJv = AzTJv + Az(i,Jv1)*T(i,-Jv)
400     CONTINUE

                 ArTIp = 0.d0
         DO 450 j = Jv1, 0
                 ArTIp = ArTIp + Ar(Ip+1,j) * T(Ip+1,j)
450      CONTINUE
cc----------------------finally compute Tvoid--------------------
                 Tnum = ArTIp/drokIp + AzTi + AzTJv/dzokJv
                 Tden = ArIp/drokIp + Azi + AzJv/dzokJv
cc......where, passed thru from MESH,
cc             drokIp = (r(Ip+1)-r2(Ip+1))/akW+(r2(Ip+1)-r(Ip))/akV 
cc             dzokJv = (z(1-Jv)-z2(1-Jv))/akV+(z2(1-Jv)-z(-Jv))/akW
cc             ArIp = 2*Pi*Rin*Zv ,  AzJv = Pi*(Rin**2) 

                   TinVOID = Tnum / Tden

c*** DONE in PHASE ********** now update T(i,j) in the void ************
cd        do 500  j = -Jv+1, 0
cd          do 550  i = 1, Ip
cd              T(i,j) = Tvoid
cd  550     continue
cd500     continue
cc--------
          return
          end

